chdir exepath

#define SND   ' auskommentieren, um keinen Sound zu verwenden

enum Listentyp
  ListAnzeige = 1, ListSperre, ListSchiebsperre, ListStopp, ListQuelle, ListZiel
  ListBeziehung, ListPunkte, ListBedingung, ListVergleich, ListAenderung
end enum

dim shared as ulong PROGRAMMVERSION = 2*&h10000000 + 0*&h100000 + 140509
dim shared as string spieldatei, spielername, pfad
dim shared as long BGC = &hffdd55, FGC = &h000000, HGRAU = &haaaaaa, DGRAU = &h555555, MBC = &h222222

dim as integer f = freefile
chdir exepath
open "datenpfad" for input as #f
line input #f, pfad
close #f

' Kommandozeilen-Argumente auswerten
if __FB_ARGC__ = 1 then
  print "patwork Version " & (PROGRAMMVERSION shr 28) & "." & ((PROGRAMMVERSION shr 20) and &hff) & "." _
        & (PROGRAMMVERSION and &hfffff)
  print "Verwenden Sie patfinder, um eine Patience auszuwaehlen,"
  print "oder geben Sie beim Aufruf die gewuenschten Parameter an."
  print
  print "Mehr Informationen erhalten Sie mit patwork -h"
  print
  end
end if
spieldatei = *__FB_ARGV__[1]
select case spieldatei
  ' einzelner Optionsschalter
  case "-v", "-version"
    print PROGRAMMVERSION
    end
  case "-h", "-hilfe"
    print "patwork Version " & (PROGRAMMVERSION shr 28) & "." & ((PROGRAMMVERSION shr 20) and &hff) & "." _
        & (PROGRAMMVERSION and &hfffff)
    print "Aufruf:"
    print "patwork Patience [-l Level] [-r Regelset] [-n Spielername]"
    print "startet die Patience, die unter Patience.xml gespeichert"
    print "ist, und verwendet dabei das angegebene Level sowie das"
    print "Regelset mit der angegebenen Nummer"
    print
    print "patwork -[h|v|c]"
    print "-h:  Dieser Hilfstext"
    print "-v:  Rueckgabe der patwork-Revisionsnummer"
    print "-c:  Start als Client; Daten kommen vom Server"
    print
    print "Um eine Auswahl der verfuegbaren Patiencen zu erhalten,"
    print "starten Sie stattdessen das Programm patfinder"
    print
    end
end select

dim shared as string*5 farben(4) = {"", "Herz", "Kreuz", "Karo", "Pik"}
dim shared as string*2 werte(14) = {"", "A", "2", "3", "4", "5", "6", "7", "8", "9", "10", "B", "D", "K", "A"}

#include once "include/xmlparse.bas"
#include once "include/http.bas"
#ifdef SND
  #include once "bass.bi"
#endif
#if defined(__FB_UNIX__)
  const slash = "/"
#elseif defined(__FB_PCOS__)
  const slash = "\"
#else
  #error "Fehler: Unbekanntes Betriebssystem!"
#endif
#include once "patinc.bi"

type TypListeninhalt
  as integer typ
  as string id, inhalt, bedingung, spec
end type
type TypListe
  as string ablauf
  declare property position(nr as integer) as long
  declare property erster(nr as integer) as long
  declare property naechster(nr as integer) as long
  declare property id(nr as integer, wert as string)
  declare property id(nr as integer) as string
  declare property inhalt(nr as integer, wert as string)
  declare property inhalt(nr as integer) as string
  declare property bedingung(nr as integer, wert as string)
  declare property bedingung(nr as integer) as string
  declare property spec(nr as integer, wert as string)
  declare property spec(nr as integer) as string
end type
dim shared as TypListe liste
redim shared as TypListeninhalt listeninhalt(0)

property TypListe.position(nr as integer) as long
  if nr < 1 or nr > len(liste.ablauf)\12 then return 0
  return cvl(mid(this.ablauf, nr*12 - 11, 4))
end property
property TypListe.erster(nr as integer) as long
  if nr < 1 or nr > len(liste.ablauf)\12 then return 0
  return cvl(mid(this.ablauf, nr*12 - 7, 4))
end property
property TypListe.naechster(nr as integer) as long
  if nr < 1 or nr > len(liste.ablauf)\12 then return 0
  return cvl(mid(this.ablauf, nr*12 - 3, 4))
end property

property TypListe.id(nr as integer, wert as string)
  if nr < 1 or nr > len(liste.ablauf)\12 then exit property
  listeninhalt(this.position(nr)).id = wert
end property
property TypListe.id(nr as integer) as string
  if nr < 1 or nr > len(liste.ablauf)\12 then return ""
  return listeninhalt(this.position(nr)).id
end property
property TypListe.inhalt(nr as integer, wert as string)
  if nr < 1 or nr > len(liste.ablauf)\12 then exit property
  listeninhalt(this.position(nr)).inhalt = wert
end property
property TypListe.inhalt(nr as integer) as string
  if nr < 1 or nr > len(liste.ablauf)\12 then return ""
  return listeninhalt(this.position(nr)).inhalt
end property
property TypListe.bedingung(nr as integer, wert as string)
  if nr < 1 or nr > len(liste.ablauf)\12 then exit property
  listeninhalt(this.position(nr)).bedingung = wert
end property
property TypListe.bedingung(nr as integer) as string
  if nr < 1 or nr > len(liste.ablauf)\12 then return ""
  return listeninhalt(this.position(nr)).bedingung
end property
property TypListe.spec(nr as integer, wert as string)
  if nr < 1 or nr > len(liste.ablauf)\12 then exit property
  listeninhalt(this.position(nr)).spec = wert
end property
property TypListe.spec(nr as integer) as string
  if nr < 1 or nr > len(liste.ablauf)\12 then return ""
  return listeninhalt(this.position(nr)).spec
end property

type TypKarte
  as byte farbe, wert
  as short status, spezial
end type
type TypFeld
  as TypKarte karte(208)
  as long     max, x, y, wiederholung, spezial, rand, eng, startfarbe, startwert, endwert, variable
  as long     llastQuellen, llastZiele, llastSperren, llastSchiebsperren, llastStopps, llastAnzeigen, llastBeziehung, llastPunkte
  as ubyte    kuerzel, anzkarten, anfangskarten(26), richtung, sichtbar, sichtbarAnfang
  as string   id, folgestart, folgefarbe, folgewert, folgeschieb, fuellen, einschub, auto
  declare property anfang(nr as integer, wert as integer)
  declare property anfang(nr as integer) as integer
end type
type TypVorlage
  as TypFeld felddaten
  as integer listenlaenge
  as TypXML legeliste(0 to 999)
end type
type TypAktion
  as long    typ, erfolg, misserfolg, llastBedingung, llastVergleich, llastAenderung
  as string  id, erfstring, misstring
end type
type TypTisch
  as integer stapel, nr
  as TypKarte karte
end type
type TypGrafikbuffer
  as integer x, y, b, h
  as any ptr bild
end type

property TypFeld.anfang(nr as integer, wert as integer)
  if nr < 0 or nr > 207 then exit property
  if this.anfangskarten(0) < nr+1 then this.anfangskarten(0) = nr+1
  if wert = 0 then
    this.anfangskarten(nr\8 + 1) = bitreset(this.anfangskarten(nr\8 + 1), nr mod 8)
  elseif wert = 1 then
    this.anfangskarten(nr\8 + 1) = bitset(this.anfangskarten(nr\8 + 1), nr mod 8)
  end if
end property
property TypFeld.anfang(nr as integer) as integer
  if nr < 0 or nr >= this.anfangskarten(0) then return -1
  return -bit(this.anfangskarten(nr\8 + 1), nr mod 8)
end property

declare function aktionslauf(typ as integer, ziel as TypTisch, start as TypTisch = type<TypTisch>(0), _
                             legen as integer = -1) as integer
declare function attribut(stapel as integer, attr as string, spec as string) as string
declare sub ausgrauen(ziel as TypTisch)
declare sub backup
declare sub berechneTisch
declare sub bewege(startfeld as TypTisch, zielstapel as integer, zielnr as integer = -1, _
                   byval typ as integer = 0, byval anz as integer = 0)
declare sub dupliziereListen(quelle as TypFeld, ziel as TypFeld)
declare sub exitTest(taste as string)
declare sub feldInit(datei as string)
declare sub feldInitParse(xmlrest as string, tag as string = "")
declare sub initParseLegeSortiere(xml as TypXML, feldptr as TypFeld ptr)
declare function findeFeld(xx as integer, yy as integer) as TypTisch
declare sub hilfe
declare function karte2wert(k as TypKarte) as integer
declare function kartenwert(k as TypKarte) as integer
declare function kartenwertParse(inhalt as string) as TypKarte
declare function legeversuch(start as TypTisch, ziel as TypTisch, legen as integer = -1, _
                             richtung as integer = 1, aktion as integer = -1, stockauf as integer = 0, _
                             anz as integer = 0) as integer
declare sub lege(start as TypTisch, ziel as TypTisch, richtung as integer = 1, einschubstopp as integer = -1, _
                 stockauf as integer = 0, byval anz as integer = 0)
declare function listeAdd overload(l as integer, inhalt as integer) as integer
declare function listeAdd(l as integer, typ as integer, id as string, inh as string, bed as string, spec as string) as integer
declare function menu as integer
declare function parseLinks(text as string, start as integer, ziel as integer) as string
declare function parseVariablen(text as string) as string
declare function pruefeAuto(start as TypTisch, ziel as integer) as integer
declare function pruefeFolge(feld as TypFeld) as integer
declare function pruefeSperre(ziel as integer, typ as integer, start as integer = 0) as integer
declare function pruefeVerschiebbar(start as TypTisch) as integer
declare function pruefeWerte(wert1 as integer, wert2 as integer, vergleich as integer) as integer
declare sub setzeAttribut(feldptr as TypFeld ptr, attr as string, wert as string, spec as string = "")
declare sub setzeBildschirm
declare sub setzeJoker(byref f as TypFeld, nr as integer)
declare sub sound_spielen(byval sound as uinteger)
declare sub spielEnde(status as integer)
declare function spielLaden as integer
declare sub spielSpeichern
declare sub stockaktion(start as TypTisch, ziel as TypTisch = type<TypTisch>(0, 0), sperrung as integer = -1)
declare sub stockaufnahme(start as TypTisch)
declare sub stopptest(start as TypTisch, ziel as TypTisch, einschubstopp as integer = -1)
declare function tempfeld(sfarbe as integer, swert as integer, ewert as integer, ffarbe as string, fwert as string, _
                 fschieb as string, einschub as string, mmax as integer, spezial as integer, k() as TypKarte) as TypFeld
declare function wert2karte(wert as integer) as TypKarte
declare sub zeichne(opt as integer = 0)
declare sub zeichneKarte(x as integer, y as integer, wert as integer, quer as integer = 0)

dim shared as long anzVorlagen, anzFelder = 0, anzAktionen = 0, anzAbschluss = 0, anzListeninhalt = 0
dim shared as long maxX = 30, maxY = 20, kartenset, anzKarten, zufallsfarbe, zufallswert
dim shared as long stopp, punkte, punktemax, punktestart, level, backpunkte, aktuellerScreen, Standardstock
dim shared as long Spielversion, markStopp = &hcc0000, markKorrekt = &hffffff, regel
dim shared as integer _Neuzeichnen = -1, kartenWaag, kartenSenk, groesse, sound = -1, animation = -1
dim shared as integer anzComputer, programmende = 0, rueckenVar = 0, endevariante = 0
dim shared as TypFeld feld(), backfeld()
dim shared as TypAktion aktion(), abschluss()
dim shared as TypKarte stapel(207)
redim shared as TypTisch tisch(maxX + 3, maxY + 5)
dim shared as any ptr kartenbild(0 to 55), kartenbildQuer(0 to 55)
dim shared as string spielregel, spielname, bemerkung, anleitung, kartenbilder, ruecken
dim as double randominit = timer

' vordefinierte Vorlagen
anzVorlagen = 7
redim shared as TypVorlage vorlage(1 to anzVorlagen)
vorlage(1).felddaten.kuerzel = asc("X") : vorlage(1).felddaten.id = "stapel"
vorlage(2).felddaten.kuerzel = asc("S") : vorlage(2).felddaten.id = "stock"
vorlage(3).felddaten.kuerzel = asc("A") : vorlage(3).felddaten.id = "abwurf"
vorlage(4).felddaten.kuerzel = asc("G") : vorlage(4).felddaten.id = "grund"
  setzeAttribut(@vorlage(4).felddaten, "auto", "ja")
vorlage(5).felddaten.kuerzel = asc("H") : vorlage(5).felddaten.id = "hilf"
vorlage(6).felddaten.kuerzel = asc("K") : vorlage(6).felddaten.id = "keller"
  setzeAttribut(@vorlage(6).felddaten, "max", "1")
  setzeAttribut(@vorlage(6).felddaten, "folgestart", "frei")
vorlage(7).felddaten.kuerzel = asc("R") : vorlage(7).felddaten.id = "reserve"
for i as integer = 1 to anzVorlagen
  vorlage(i).felddaten.sichtbar = 209
  vorlage(i).felddaten.sichtbarAnfang = 209
next

kartenbilder = "40standard"
ruecken = "40standard"
' weitere Komandozeilen-Argumente auswerten
dim as integer argument = 2
do while argument < __FB_ARGC__
  select case *__FB_ARGV__[argument]
  case "-l", "-level"
    argument += 1
    if argument < __FB_ARGC__ then level = valint(*__FB_ARGV__[argument])
    if level < 0 then level = 0
  case "-r", "-regel"
    argument += 1
    if argument < __FB_ARGC__ then regel = valint(*__FB_ARGV__[argument])
  case "-n", "-name"
    argument += 1
    if argument < __FB_ARGC__ then spielername = *__FB_ARGV__[argument]
    ' Benutzerdaten einlesen
    if dir(pfad & "benutzer" & slash & spielername & slash & "einstellung") <> "" then
      dim f as integer = freefile, temp as string
      open pfad & "benutzer" & slash & spielername & slash & "einstellung" for input as #f
      line input #f, kartenbilder
      line input #f, ruecken
      if instrrev(ruecken, " ") = len(ruecken) - 1 then
        rueckenVar = valint(right(ruecken, 1))
        ruecken = left(ruecken, len(ruecken)-2)
      end if
      line input #f, temp
      #ifdef SND
        sound = valint(temp)
      #endif
      line input #f, temp
      animation = valint(temp)
      line input #f, temp
      BGC = valint(temp)
      close #f
    end if
  case "-z", "-zufall"
    argument += 1
    if argument < __FB_ARGC__ then randominit = valint(*__FB_ARGV__[argument])
  end select
  argument += 1
loop
randomize randominit
groesse = valint(left(kartenbilder, 2)) \ 4

' Sound initialisieren
dim shared as string FILE_LEGEN, FILE_MISCH
FILE_LEGEN = "snd" & slash & "legen.ogg"
FILE_MISCH = "snd" & slash & "misch.ogg"
dim shared as uinteger sound_legen, sound_misch
#ifdef SND
  if sound <> 0 andalso BASS_Init(-1, 44100, BASS_DEVICE_8BITS, 0, 0) <> 0 then
    sound = SOUND_EFFEKT_OK
  end if
  if sound > 0 then
    sound_legen = BASS_SampleLoad(0, strptr(FILE_LEGEN), 0, 0, 16, 0)
    sound_misch = BASS_SampleLoad(0, strptr(FILE_MISCH), 0, 0, 16, 0)
  end if
#endif
if sound < 0 then sound = 0

feldinit spieldatei
berechneTisch
zeichne
aktionslauf ATypBeginn, type<TypTisch>(1, 0, feld(1).karte(0))

dim as integer mx, my, mb, mx2, my2, mx2b, my2b, mb2, xplus, yplus, xzplus, yzplus, xz, yz, wz, hz, xz2, yz2, temph2
dim as integer wert, graux, grauy, z
dim as TypTisch startfeld, zielfeld, zieltisch
dim as TypKarte startkarte
dim as string taste

do
  do
    getmouse mx, my,, mb
    taste = inkey
    if taste = chr(27) orelse mb = 1 and mx > (maxX+2)*groesse-25 and my > (maxY+6)*groesse+1 then
      select case menu
        case 1  : spielEnde EndeVerlust
        case 2  : if len(spielername) then spielEnde EndeNeu
        case 3  : spielSpeichern : spielEnde EndeSpeichern
        case 5  : taste = chr(8)
        case 6  : animation = not animation
        case 7  : taste = "h"
        case -1 : taste = chr(255, 107) : exit do
      end select
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb < 1
    end if
    select case taste
      case "h", "H" : hilfe
      case "r", "R" : zeichne
' TODO: LOESCHMICH!!
case "S"
open "0_screenshots/0_info" for output as #99
print #99, spieldatei
print #99, maxX
print #99, maxY
close #99
shell "xfce4-screenshooter -w -o 0_screenshots/0_screenshooter"
      case "a", "A"
        dim as integer gelegt
        do
          gelegt = 0
          dim as TypTisch start, ziel
          for i as integer = 1 to anzFelder
            if feld(i).spezial and SAuto andalso feld(i).auto = "" then continue for
            if feld(i).anzKarten < 1 then continue for
            if feld(i).spezial and SGesperrt then continue for
            start = type<TypTisch>(i, feld(i).anzKarten-1, feld(i).karte(feld(i).anzKarten-1))
            if not pruefeVerschiebbar(start) then continue for
            if feld(i).karte(feld(i).anzKarten-1).status = Verdeckt or (feld(i).spezial and SVerdeckt) <> 0 then continue for
            for k as integer = 1 to anzFelder
              if (feld(k).spezial and SAuto) = 0 then continue for
              if feld(i).auto <> "" and feld(i).auto = feld(k).auto then continue for
              if pruefeAuto(start, k) = 0 then continue for
              if feld(k).anzKarten > 0 then
                ziel = type<TypTisch>(k, feld(k).anzKarten-1, feld(k).karte(feld(k).anzKarten-1))
              else
                ziel = type<TypTisch>(k, 0, feld(k).karte(0))
              end if
              if legeversuch(start, ziel, 0) = -1 then
                bewege start, k
                legeversuch start, ziel
                gelegt = -1
                berechneTisch
                zeichne
                aktionslauf(ATypAbschluss or ATypLegen, ziel, start)
                exit for
              end if
            next
            if inkey = "a" then exit do
          next
        loop until gelegt = 0
      case chr(8)
        if backpunkte > 0 then
          for i as integer = 1 to anzFelder
            feld(i) = backfeld(i)
          next
          backpunkte = 0
          stopp = 0
          berechneTisch
          zeichne
        end if
    end select
    if taste = chr(255, 107) or (punkte >= punktemax and punktemax > 0) then exit do
    sleep 1
  loop until mb = 1 or mb = 2 or mb = 4
  exitTest(taste)
  if mx < 0 orelse my < 0 orelse mx\groesse > maxX + 3 orelse my\groesse > maxY + 5 then continue do ' Bugfix Linux-Version
  startfeld = tisch(mx\groesse, my\groesse)
  dim as integer f = startfeld.stapel
  dim as integer suche, maustyp, anzeigestart
  select case mb
    case 1 : maustyp = ATypLinks
    case 2 : maustyp = ATypRechts
    case 4 : maustyp = ATypMitte
  end select
  ' Aktionen ueberpruefen
  if f > 0 then
    suche = aktionslauf(maustyp, startfeld)
    if suche then
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb = 0
      berechneTisch
      aktionslauf(ATypAbschluss or maustyp, startfeld)
      zeichne
      continue do
    end if
  end if
  ' Karten geben (Klick auf den Stock)
  if f > 0 then
    if liste.erster(feld(f).llastZiele) > 0 then
      do
        getmouse mx, my,, mb
        sleep 1
      loop until mb < 1
      if mx > 0 and my > 0 and mx\groesse <= maxX + 3 and my\groesse <= maxY + 5 then _
         zielfeld = tisch(mx\groesse, my\groesse)
      if f <> zielfeld.stapel or startfeld.nr <> zielfeld.nr then continue do
      stockaktion startfeld
      aktionslauf(ATypAbschluss or ATypLegen, zielfeld, startfeld)
    elseif feld(f).anzkarten = 0 then
      ' Stockaufnahme auch moeglich, wenn nicht wie beim Stock gegeben wird
      stockaufnahme(startfeld)
      aktionslauf(ATypAbschluss or maustyp, startfeld)
    end if
  end if
  wert = karte2wert(startfeld.karte)
  if wert < 1 or wert > 57 or (wert mod 14) = 0 orelse not pruefeVerschiebbar(startfeld) then
    do
      getmouse mx, my,, mb
      sleep 1
    loop until mb < 1
    continue do
  end if
  if mb = 2 then    ' versuche, automatisch zu legen
    for i as integer = 1 to anzFelder
      if pruefeAuto(startfeld, i) then
        if feld(i).anzKarten > 0 then
          if legeversuch(startfeld, type<TypTisch>(i, feld(i).anzKarten-1, feld(i).karte(feld(i).anzKarten-1)), 0) = -1 then
            bewege startfeld, i,,, -(feld(startfeld.stapel).folgeschieb = "einzeln")
            legeversuch startfeld, type<TypTisch>(i, feld(i).anzKarten-1, feld(i).karte(feld(i).anzKarten-1))
            aktionslauf(ATypAbschluss or ATypLegen, type(i, feld(i).anzKarten-1), startfeld)
            exit for
          end if
        else
          if legeversuch(startfeld, type<TypTisch>(i, 0, feld(i).karte(0)), 0) = -1 then
            bewege startfeld, i,,, -(feld(startfeld.stapel).folgeschieb = "einzeln")
            legeversuch startfeld, type<TypTisch>(i, 0, feld(i).karte(0))
            aktionslauf(ATypAbschluss or ATypLegen, type<TypTisch>(i, 0, feld(i).karte(0)), startfeld)
            exit for
          end if
        end if
      end if
    next
    do
      getmouse mx, my,, mb
      sleep 1
    loop until mb < 1
  else              ' normales Legen
    with feld(startfeld.stapel)
      anzeigestart = iif(.sichtbar < .anzkarten, .anzKarten-.sichtbar, 0)
      xzplus = mx - feld(startfeld.stapel).x*groesse
      yzplus = my - feld(startfeld.stapel).y*groesse
      ' Ecken fuer den Zeichenbereich bestimmen
      if feld(startfeld.stapel).eng > 0 andalso feld(startfeld.stapel).anzKarten >= feld(startfeld.stapel).eng then
        richtungsadd .richtung, xzplus, yzplus, _
            groesse*(.anzKarten-anzeigestart-1), -groesse*(startfeld.nr-anzeigestart), _
            groesse*(.anzKarten-anzeigestart-1), -groesse*(startfeld.nr-anzeigestart)
      else
        richtungsadd feld(startfeld.stapel).richtung, xzplus, yzplus, _
            groesse*(.anzKarten+startfeld.nr-2*anzeigestart-1), -2*groesse*(startfeld.nr-anzeigestart), _
            groesse*(.anzKarten+startfeld.nr-2*anzeigestart-1), -2*groesse*(startfeld.nr-anzeigestart)
      end if
      ' temporaeres Bild und Ersatzspeicher erstellen
      dim as any ptr bild, ersatz
      dim as integer tempw = 4*groesse, temph = 6*groesse, tempx = 0, tempy = 0
      if .spezial and SQuer then swap tempw, temph
      if .folgeschieb <> "einzeln" then
        if .richtung and (RLinks or RRechts) then
          tempw += groesse*(.anzKarten-startfeld.nr-1)
          if .richtung and RLinks then tempx = tempw - 4*groesse
        end if
        if .richtung and (ROben or RUnten) then
          temph += groesse*(.anzKarten-startfeld.nr-1)
          if .richtung and ROben then tempy = temph - 6*groesse
        end if
      end if
      bild = imagecreate(tempw, temph, &hff00ff)
      ersatz = imagecreate(tempw, temph, &hff00ff)
      for i as integer = startfeld.nr to .anzKarten - 1
        if .folgeschieb = "einzeln" and i > startfeld.nr then exit for
        if .spezial and SQuer then
          put bild, (tempx, tempy), kartenbildQuer(kartenwert(.karte(i))), pset
        else
          put bild, (tempx, tempy), kartenbild(kartenwert(.karte(i))), pset
        end if
        richtungsadd .richtung, tempx, tempy, -groesse, groesse, -groesse, groesse
      next
      setmouse ,,0
      startkarte = .karte(startfeld.nr)
      ' Mittelpunkt der geschobenen Karte bestimmen
      if .richtung and RLinks then xplus = xzplus - tempw + 4*groesse else xplus = xzplus
      if .richtung and ROben then yplus = yzplus - temph + 6*groesse else yplus = yzplus
    end with
    ' Ziel der Verschiebung bestimmen
    mx2b = mx
    my2b = my
    zielfeld = findeFeld(mx2b-xplus+20, my2b-yplus+30)
    if zielfeld.stapel = 0 then setmouse ,,1 : continue do   ' Sicherung fuer evtl. Fehler
    zieltisch = type<TypTisch>(zielfeld.stapel, feld(zielfeld.stapel).anzKarten)
    xz = mx - xzplus
    yz = my - yzplus
    wz = xz + tempw - 1
    hz = yz + temph - 1
    xz2 = iif(xz < 0, 0, iif(xz > (maxX+4)*groesse - 1, (maxX+4)*groesse - 1, xz))
    yz2 = iif(yz < 0, 0, iif(yz > (maxY+6)*groesse - 1, (maxY+6)*groesse - 1, yz))
    if wz > (maxX+4)*groesse - 1 then wz = (maxX+4)*groesse - 1
    if hz > (maxY+6)*groesse - 1 then hz = (maxY+6)*groesse - 1
    screenlock
    ausgrauen startfeld
    if startfeld.stapel <> zielfeld.stapel then ausgrauen zielfeld
    get (xz, yz)-(wz, hz), ersatz
    put (xz, yz), bild, (0, 0)-step(wz-xz, hz-yz), trans
    screenunlock
    do
      if getmouse(mx2, my2,, mb2) then mx2 = -1 : mb2 = -1  ' Bugfix für ältere Linux-Version
      if mx2 < 0 then setmouse ,,1
      taste = inkey
      if taste = chr(255, 107) then exit do
      if mx2 <> mx2b or my2 <> my2b then
        screenlock
        if mx2b >= 0 then put (xz2, yz2), ersatz, pset
        if startfeld.stapel <> zielfeld.stapel andalso legeversuch(startfeld, zieltisch, 0) = -1 then ausgrauen zielfeld
        if mx2b >= 0 then zielfeld = findeFeld(mx2b-xplus+20, my2b-yplus+30) else zielfeld = type<TypTisch>(0)
        if zielfeld.stapel = 0 then
          zieltisch = type<TypTisch>(0)
        else
          zieltisch = type<TypTisch>(zielfeld.stapel, feld(zielfeld.stapel).anzKarten)
        end if
        if startfeld.stapel <> zielfeld.stapel andalso legeversuch(startfeld, zieltisch, 0) = -1 then ausgrauen zielfeld
        screenunlock
        if mx2 >= 0 then
          xz = mx2 - xzplus
          yz = my2 - yzplus
          wz = xz + tempw - 1
          hz = yz + temph - 1
          temph2 = temph
          xz2 = iif(xz < 0, 0, iif(xz > (maxX+4)*groesse - 1, (maxX+4)*groesse - 1, xz))
          yz2 = iif(yz < 0, 0, iif(yz > (maxY+6)*groesse - 1, (maxY+6)*groesse - 1, yz))
          if wz > (maxX+4)*groesse - 1 then wz = (maxX+4)*groesse - 1
          if hz > (maxY+6)*groesse then
            hz = (maxY+6)*groesse
            temph2 = hz - yz
          end if
          screenlock
          get (xz2, yz2)-(wz, hz), ersatz
          put (xz, yz), bild, (0, 0)-(tempw, temph2), trans
          screenunlock
        end if
        if mx2b = -1 and mx2 >= 0 then setmouse ,,0
        mx2b = mx2
        my2b = my2
      end if
      sleep 1
    loop until mb2 = 0
    screenlock
    put (xz2, yz2), ersatz, pset
    if startfeld.stapel <> zielfeld.stapel andalso legeversuch(startfeld, zieltisch, 0) = -1 then ausgrauen zielfeld
    ausgrauen startfeld
    screenunlock
    setmouse ,,1
    imagedestroy bild
    imagedestroy ersatz
    if taste <> chr(27) and taste <> chr(255, 107) then
      ' ueberpruefe, ob Karte gelegt werden kann
      if legeversuch(startfeld, zielfeld) then aktionslauf(ATypAbschluss or ATypLegen, zielfeld, startfeld)
    end if
  end if
  exitTest(taste)
loop until (punkte >= punktemax and punktemax > 0)
spielEnde EndeSieg

function aktionslauf(typ as integer, ziel as TypTisch, start as TypTisch = type<TypTisch>(0), _
                     legen as integer = -1) as integer
  ' Aktionen ueberpruefen
  if ziel.stapel = 0 orelse (typ and ATypLegen) = ATypLegen and start.stapel = 0 then return 0
  if ziel.nr < 0 then
    ziel.karte = type(0, 0, 0)
  else
    ziel.karte = feld(ziel.stapel).karte(ziel.nr)
  end if
  if start.stapel > 0 then
    start.karte = feld(start.stapel).karte(start.nr)
  end if
  dim as integer aktionenzahl = iif(typ and (ATypAbschluss or ATypBeginn or ATypEnde), anzAbschluss, anzAktionen), i = 1
  dim as integer erfolgreich = 0, soundGespielt, gelegt
  do while i <= aktionenzahl and i > 0
    gelegt = 0
    soundGespielt = 0
    sleep 1
    dim as TypAktion ptr aktaktion
    if typ and (ATypAbschluss or ATypBeginn or ATypEnde) then aktaktion = @abschluss(i) else aktaktion = @aktion(i)
    dim as integer gefunden = -1
    if ((*aktaktion).typ and typ) = 0 _
       and ((*aktaktion).typ <> ATypKlick or (typ <> ATypLinks and typ <> ATypRechts)) _
       and ((*aktaktion).typ <> ATypEnde or (typ <> ATypSieg and typ <> ATypVerlust)) _
       then i += 1 : continue do
    dim as integer bed = liste.erster((*aktaktion).llastBedingung)
    do while bed <> 0
      gefunden = 0
      with liste
        dim as integer farbe, wert
        if .bedingung(bed) = "karte" or .bedingung(bed) = "start" or .bedingung(bed) = "startfolge" then
          let (farbe, wert) = kartenwertParse(.inhalt(bed))
        end if
        select case .bedingung(bed)
        case "karte"
          ' Kartenbedingung pruefen
          dim as integer spec = valint("&h" & left(.spec(bed), 4)), nr_ = valint("&h" & mid(.spec(bed), 5)), nr
          dim as string idliste = parseLinks(.id(bed), start.stapel, ziel.stapel)
          for k as integer = 1 to anzFelder
            if idliste = " quelle " then
              if start.stapel <> k then continue for
            elseif idliste = " ziel " then
              if ziel.stapel <> k then continue for
            else
              if instr(idliste, feld(k).id) = 0 then continue for
            end if
            if feld(k).anzKarten = 0 then continue for
            if feld(k).anzKarten < abs(nr) then continue for
            if nr_ < 0 then
              nr = feld(k).anzKarten + nr_
            elseif nr_ = 0 then
              nr = feld(k).anzKarten - 1
            else
              nr = nr_ - 1
            end if
            if spec = (VGroesser or VKleiner) then
              if farbe > 0 and feld(k).karte(nr).farbe <> farbe then
                gefunden = -1
                exit for
              elseif wert = 0 then
                continue for
              end if
            else
              if farbe > 0 and feld(k).karte(nr).farbe <> farbe then continue for
            end if
            if wert > 0 then
              dim as integer feldwert = feld(k).karte(nr).wert
              if pruefeWerte(feldwert, wert, spec) = 0 then continue for
            end if
            gefunden = -1
            exit for
          next
        case "start", "startfolge", "folge"
          dim as string idliste = parseLinks(.id(bed), start.stapel, ziel.stapel)
          for k as integer = 1 to anzFelder
            if idliste = " quelle " then
              if start.stapel <> k then continue for
            elseif .id(bed) = " ziel " then
              if ziel.stapel <> k then continue for
            else
              if instr(idliste, feld(k).id) = 0 then continue for
            end if
            dim as integer tkartenzahl = 1
            if .bedingung(bed) <> "folge" and feld(k).anzKarten > 0 then tkartenzahl = feld(k).anzKarten
            dim as TypKarte tkarte(tkartenzahl - 1)
            dim as integer sfarbe, swert
            dim as string ffarbe = feld(k).folgewert, fwert = feld(k).folgewert
            select case .spec(bed)
              case "farbe"       : ffarbe = "gleich"
              case "farbwechsel" : ffarbe = "wechsel"
              case "wert"        : fwert  = "gleich"
              case "offen"       ' TODO: NOCH UMZUSETZEN!
            end select
            if len(.spec(bed)) > 4 andalso left(.spec(bed), 4) = "wert" then fwert = mid(.spec(bed), 5)
            let (sfarbe, swert) = kartenwertParse(.inhalt(bed))
            if sfarbe = 0 then sfarbe = feld(k).startfarbe
            if swert = 0 then swert = feld(k).startwert
            with feld(k)
              for j as integer = 0 to tkartenzahl - 1
                tkarte(j) = .karte(j)
              next
              dim as TypFeld tfeld = tempfeld(sfarbe, swert, .endwert, ffarbe, fwert, _
                                              .folgeschieb, .einschub, .max, .spezial, tkarte())
            end with
            if .bedingung(bed) = "folge" then
              tfeld.startfarbe = -1
              tfeld.startwert = 0
            end if
            if farbe > 0 then tfeld.startfarbe = farbe else if wert > 0 then tfeld.startfarbe = 0
            if wert > 0 then tfeld.startwert = wert else if farbe > 0 then tfeld.startwert = 0
            if pruefeFolge(tfeld) = 0 then continue for
            gefunden = -1
            exit for
          next
        case "legezahl"
          if pruefeWerte(feld(start.stapel).anzKarten - start.nr, valint(.inhalt(bed)), valint(.spec(bed))) = 0 then exit do
          gefunden = -1
        case "legbar"
          dim as string idliste = parseLinks(.id(bed), start.stapel, ziel.stapel)
          for k as integer = 1 to anzFelder
            if idliste = " quelle " then
              if start.stapel <> k then continue for
            elseif .id(bed) = " ziel " then
              if ziel.stapel <> k then continue for
            else
              if instr(idliste, feld(k).id) = 0 then continue for
            end if
            for l as integer = 1 to anzFelder
              ' ID ueberpruefen
              if k = l then continue for
              dim as string idliste2 = parseLinks(" " & .inhalt(bed) & " ", start.stapel, ziel.stapel)
              if idliste2 = " quelle " then
                if start.stapel <> l then continue for
              elseif idliste2 = " ziel " then
                if ziel.stapel <> l then continue for
              else
                if instr(idliste2, feld(l).id) = 0 then continue for
              end if
              ' Umschichtung
              if (valint(.spec(bed)) and ChUmschichtenAuf) = ChUmschichtenAuf then
                if feld(k).anzKarten > feld(l).anzKarten then continue for
              elseif (valint(.spec(bed)) and ChUmschichtenAb) = ChUmschichtenAb then
                if feld(k).anzKarten <= feld(l).anzKarten then continue for
              end if
              ' Legbarkeit pruefen
              if idliste = " quelle " then
                if legeversuch(type<TypTisch>(k, start.nr), type<TypTisch>(l, feld(l).anzKarten), _
                   0, 1, 0) then gefunden = -1 : exit for
              else
                if legeversuch(type<TypTisch>(k, feld(k).anzKarten - 1), type<TypTisch>(l, feld(l).anzKarten), _
                   0, 1, 0) then gefunden = -1 : exit for
              end if
            next
            if gefunden then exit for
          next
        case else
          ' Tag-Bedingung pruefen
          dim as string inhalt = parseVariablen(.inhalt(bed)), wert
          dim as integer vgl
          select case .bedingung(bed)
            case "sicht", "status", "anzeige", "sperre", "schiebsperre" : vgl = VGleich
            case else : vgl = valint(.spec(bed))
          end select
          if inhalt = "quelle" then
            inhalt = attribut(start.stapel, .bedingung(bed), .spec(bed))
          elseif inhalt = "ziel" then
            inhalt = attribut(ziel.stapel, .bedingung(bed), .spec(bed))
          end if
          dim as string idliste = parseLinks(.id(bed), start.stapel, ziel.stapel)
          for k as integer = 1 to anzFelder
            if idliste = " quelle " then
              if start.stapel <> k then continue for
            elseif idliste = " ziel " then
              if ziel.stapel <> k then continue for
            else
              if instr(idliste, feld(k).id) = 0 then continue for
            end if
            wert = attribut(k, .bedingung(bed), .spec(bed))
            if .bedingung(bed) = "id" then
              if instr(" " & inhalt & " ", " " & wert & " ") = 0 then continue for
            else
              if vgl and VGleich then
                if wert <> inhalt then continue for
              else
                if pruefeWerte(valint(wert), valint(inhalt), vgl) = 0 then continue for
              end if
            end if
            gefunden = -1
            exit for
          next
        end select
      end with
      if gefunden = 0 then exit do
      bed = liste.naechster(bed)
    loop
    if gefunden = 0 then i = (*aktaktion).misserfolg : continue do
    bed = liste.erster((*aktaktion).llastVergleich)
    do while bed <> 0
      gefunden = 0
      with liste
        ' zwei Karten vergleichen
        dim as string idliste = parseLinks(.id(bed), start.stapel, ziel.stapel)
        for k as integer = 1 to anzFelder
          if idliste = " quelle " then
            if start.stapel <> k then continue for
          elseif idliste = " ziel " then
            if ziel.stapel <> k then continue for
          else
            if instr(idliste, feld(k).id) = 0 then continue for
          end if
          if feld(k).anzKarten = 0 then continue for     ' keine Karte, keine Vergleichsmoeglichkeit
          dim as string idliste2 = parseLinks(.inhalt(bed), start.stapel, ziel.stapel)
          for l as integer = 1 to anzFelder
            if k = l then continue for
            if idliste2 = " quelle " then
              if start.stapel <> l then continue for
            elseif idliste2 = " ziel " then
              if ziel.stapel <> l then continue for
            else
              if instr(idliste2, feld(l).id) = 0 then continue for
            end if
            if feld(l).anzKarten = 0 then continue for   ' keine Karte, keine Vergleichsmoeglichkeit
            dim as integer wert, vwert = valint(.spec(bed)) and 31
            dim as integer vvergl = valint(.spec(bed)) and (VVergleich or VFarbvergleich)
            dim as TypKarte t1 = feld(k).karte(feld(k).anzkarten-1), t2 = feld(l).karte(feld(l).anzkarten-1)
            select case .bedingung(bed)
              case "summe"
                wert = t1.wert + t2.wert
              case "differenz"
                wert = (t1.wert - t2.wert + 13) mod 13
              case "abstand"
                wert = abs(t1.wert - t2.wert)
                if vwert > 6 then vwert = 13 - vwert
              case "farbe"
                select case vvergl
                  case VFarbwechsel  : if ((t1.farbe and 1) xor (t2.farbe and 1)) = 0 then continue for
                  case VFarbSR       : if (t1.farbe and 1) xor (t2.farbe and 1) then continue for
                  case VFarbgleich   : if t1.farbe <> t2.farbe then continue for
                  case VFarbungleich : if t1.farbe = t2.farbe then continue for
                end select
              case "wert"
                wert = t1.wert
                vwert = t2.wert
            end select
            if .bedingung(bed) <> "farbe" then if pruefeWerte(wert, vwert, vvergl) = 0 then continue for
            gefunden = -1
            exit for
          next
        next
      end with
      if gefunden = 0 then exit do
      bed = liste.naechster(bed)
    loop
    if gefunden = 0 then i = (*aktaktion).misserfolg : continue do
    ' alle Tests wurden erfolgreich bestanden; Aktion durchfuehren
    if liste.erster((*aktaktion).llastAenderung) = 0 then return -2 ' "leere" Aktion; soll nicht ausgrauen
    if legen = 0 then return -1 ' erfolgreich, aber Aktion soll nicht durchgefuehrt werden
    backup
    _Neuzeichnen = 0
    bed = liste.erster((*aktaktion).llastAenderung)
    do while bed <> 0
      select case valint(liste.spec(bed)) _
                  and (ChAenderung or ChLegen or ChWarten or ChMeldung or ChSound or ChSpielende)
      case ChAenderung
        ' Tag-Aenderungen vornehmen
        dim spec as integer = valint(liste.spec(bed)) and ChGesamt
        dim as string id = parseLinks(liste.id(bed), start.stapel, ziel.stapel), merke1, merke2
        dim as string inhalt = parseLinks(liste.inhalt(bed), start.stapel, ziel.stapel)
        if valint(liste.spec(bed)) and ChTausch then
          inhalt = " " & inhalt & " "
          ' alte Belegungen finden und merken
          select case id
            case " quelle " : merke1 = attribut(start.stapel, liste.bedingung(bed), "")
            case " ziel "   : merke1 = attribut(ziel.stapel, liste.bedingung(bed), "")
            case else
              dim as string idliste = parseLinks(.id, start.stapel, ziel.stapel)
              for j as integer = 1 to anzFelder
                if instr(feld(j).id, id) then merke1 = attribut(j, liste.bedingung(bed), "") : exit for
              next
          end select
          select case inhalt
            case " quelle " : merke2 = attribut(start.stapel, liste.bedingung(bed), "")
            case " ziel "   : merke2 = attribut(ziel.stapel, liste.bedingung(bed), "")
            case else
              for j as integer = 1 to anzFelder
                if instr(feld(j).id,  inhalt) then merke2 = attribut(j, liste.bedingung(bed), "") : exit for
              next
          end select
        end if
        ' Aenderungen durchfuehren
        if spec <> ChEinzel then
          if id = " quelle " andalso start.stapel > 0 then id = feld(start.stapel).id
          if id = " ziel " then id = feld(ziel.stapel).id
          if inhalt = " quelle " andalso start.stapel > 0 then inhalt = feld(start.stapel).id
          if inhalt = " ziel " then inhalt = feld(ziel.stapel).id
        end if 
        dim as integer qfund, zfund
        for j as integer = 1 to anzFelder
          qfund = -1
          zfund = -1
          if id = " quelle " then
            if j <> start.stapel then qfund = 0
          elseif id = " ziel " then
            if j <> ziel.stapel then qfund = 0
          else
            if instr(id, feld(j).id) = 0 then qfund = 0
          end if
          if inhalt = " quelle " then
            if j <> start.stapel then zfund = 0
          elseif inhalt = " ziel " then
            if j <> ziel.stapel then zfund = 0
          else
            if instr(inhalt, feld(j).id) = 0 then zfund = 0
          end if
          if valint(liste.spec(bed)) and ChTausch then
            dim as string tag = liste.bedingung(bed)
            if qfund then setzeAttribut @feld(j), tag, merke2
            if zfund then setzeAttribut @feld(j), tag, merke1
          else
            ' spezielle Angaben umsetzen
            dim as string neuerwert
            select case liste.inhalt(bed)
              case "quellfarbe"  : if start.stapel > 0 then neuerwert = farben(feld(start.stapel).karte(start.nr).farbe)
              case "quellwert"   : if start.stapel > 0 then neuerwert = werte(feld(start.stapel).karte(start.nr).wert)
              case "zielfarbe"   : neuerwert = farben(feld(ziel.stapel).karte(start.nr).farbe)
              case "zielwert"    : neuerwert = werte(feld(ziel.stapel).karte(start.nr).wert)
              case else : neuerwert = liste.inhalt(bed)
            end select
            if qfund then
              if liste.bedingung(bed) = "sortieren" then
                ' verschiedene Sortierarten
                select case liste.inhalt(bed)
                  case "mischen"
                    for m as integer = 0 to feld(j).anzKarten - 1
                      for n as integer = m + 1 to feld(j).anzKarten - 1
                        if rnd*(n-m+1) < 1 then swap feld(j).karte(m), feld(j).karte(n)
                      next
                    next
                  case "umdrehen"
                    for m as integer = 0 to feld(j).anzKarten \ 2 - 1
                      swap feld(j).karte(m), feld(j).karte(feld(j).anzKarten - 1 - m)
                    next
                end select
              else
                dim as string tag = liste.bedingung(bed), spec = ""
                if left(tag, 7) = "status " then
                  spec = mid(tag, 8)
                  tag = "status"
                end if
                if left(tag, 8) = "anzeige " then
                  spec = mid(tag, 9)
                  tag = "anzeige"
                end if
                if left(tag, 7) = "sperre " then
                  spec = mid(tag, 8)
                  tag = "sperre"
                end if
                if left(tag, 13) = "schiebsperre " then
                  spec = mid(tag, 14)
                  tag = "schiebsperre"
                end if
                setzeAttribut @feld(j), tag, neuerwert, spec
              end if
            end if
          end if
        next
      case ChLegen
        ' Karten legen
        dim as string f1 = parseLinks(liste.id(bed), start.stapel, ziel.stapel)
        dim as string f2 = parseLinks(liste.inhalt(bed), start.stapel, ziel.stapel)
        dim as integer spec = valint(liste.spec(bed))
        if (spec and ChGesamt) <> ChEinzel then
          if f1 = " quelle " and start.stapel > 0 then f1 = feld(start.stapel).id
          if f1 = " ziel " then f1 = feld(ziel.stapel).id
          if f2 = " quelle " and start.stapel > 0 then f2 = feld(start.stapel).id
          if f2 = " ziel " then f2 = feld(ziel.stapel).id
        end if
        for k as integer = 1 to AnzFelder
          if f1 = " quelle " then
            if k <> start.stapel then continue for
          elseif f1 = " ziel " then
            if k <> ziel.stapel then continue for
          else
            if instr(f1, feld(k).id) = 0 then continue for
          end if
          for l as integer = 1 to AnzFelder
            ' ID ueberpruefen
            if k = l then continue for
            if f2 = " quelle " then
              if l <> start.stapel then continue for
            elseif f2 = " ziel " then
              if l <> ziel.stapel then continue for
            else
              if instr(f2, feld(l).id) = 0 then continue for
            end if
            ' Umschichtung
            if (spec and ChUmschichtenAuf) = ChUmschichtenAuf then
              if feld(k).anzKarten > feld(l).anzKarten then continue for
            elseif (spec and ChUmschichtenAb) = ChUmschichtenAb then
              if feld(k).anzKarten <= feld(l).anzKarten then continue for
            end if
            ' betroffene Karten suchen
            dim as integer anz, richtung = iif(spec and ChLegeRueckwaerts, -1, 1)
            dim as string bed1 = left(liste.bedingung(bed), 4), _
                          bed2 = mid(liste.bedingung(bed), 5, 4), _
                          bed3 = right(liste.bedingung(bed), 4)
            dim as short start1 = valint("&h" & bed2), start2 = valint("&h" & bed3)
            if bed1 = "lege" then anz = feld(start.stapel).anzKarten-start.nr else anz = valint("&h" & bed1)
            if anz = 0 then
              if start1 = 0 then anz = 1 else anz = feld(k).anzKarten - start1 + 1
              if anz = 0 then anz = -1
            end if
            if start1 > 0 then
              start1 -= 1
            elseif start1 = 0 then
              start1 = feld(k).anzKarten - anz
            else
              start1 = feld(k).anzKarten + start1
            end if
            if start1 < 0 then start1 = 0
            if start2 > 0 then
              start2 -= 1
              if start2 > feld(l).anzKarten then start2 = feld(l).anzKarten
            else
              start2 = feld(l).anzKarten + start2
              if start2 < 0 then start2 = 0
            end if
            anz = iif(anz > feld(k).anzKarten-start1, feld(k).anzKarten-start1, anz)
            ' Karte(n) legen
            dim as integer erfolgreich = -1
            if spec and ChTausch then
              if spec and (ChAniOffen or ChAniVerdeckt) then _
                 bewege type<TypTisch>(k, start1), l, start2, spec and (ChAniOffen or ChAniVerdeckt), anz
              lege type<TypTisch>(k, start1), type<TypTisch>(l, iif(start2<anz, 0, start2-anz)), richtung,, -1, anz
              lege type<TypTisch>(l, iif(start2<anz, anz, cast(integer, start2))) _
                   , type<TypTisch>(k, start1), richtung,, -1, iif(start2<anz, cast(integer, start2), anz)
              gelegt = -1
            else
              if spec and ChErlaubt then
                erfolgreich = legeversuch(type<TypTisch>(k, start1), type<TypTisch>(l, feld(l).anzKarten), 0, 1, 0,, anz)
                if erfolgreich then
                  if spec and (ChAniOffen or ChAniVerdeckt) then _
                     bewege type<TypTisch>(k, start1), l, start2, spec and (ChAniOffen or ChAniVerdeckt), anz
                  if (spec and ChOffen) = ChOffen then
                    for m as integer = k to k+anz
                      feld(k).karte(m).spezial and= not SVerdeckt
                    next
                  elseif (spec and ChVerdeckt) = ChVerdeckt then
                    for m as integer = k to k+anz
                      feld(k).karte(m).spezial or= SVerdeckt
                    next
                  end if
                  lege type<TypTisch>(k, start1), type<TypTisch>(l, feld(l).anzKarten), richtung,, -1, anz
                  erfolgreich = -1
                  gelegt = -1
                end if
              else
                if spec and (ChAniOffen or ChAniVerdeckt) then _
                   bewege type<TypTisch>(k, start1), l, start2, spec and (ChAniOffen or ChAniVerdeckt), anz
                if (spec and ChOffen) = ChOffen then
                  for m as integer = start1 to start1+anz
                    feld(k).karte(m).status and= not Verdeckt
                  next
                elseif (spec and ChVerdeckt) = ChVerdeckt then
                  for m as integer = start1 to start1+anz
                    feld(k).karte(m).status or= Verdeckt
                  next
                end if
                lege type<TypTisch>(k, start1), type<TypTisch>(l, start2), richtung,, -1, anz
                gelegt = -1
              end if
            end if
            if erfolgreich andalso spec and ChLegeEinmal then exit for, for
          next
        next
      case ChMeldung
        color &hffffff
        dim as integer temp = nachricht(liste.inhalt(bed), liste.bedingung(bed))
        color 0
        if liste.id(bed) <> "" then
          select case liste.id(bed)
            case " quelle " : setzeAttribut @feld(start.stapel), "var", str(temp)
            case " ziel "   : setzeAttribut @feld(ziel.stapel), "var", str(temp)
            case else
              for j as integer = 1 to anzFelder
                if instr(feld(j).id, liste.id(bed)) then setzeAttribut @feld(j), "var", str(temp) : exit for
              next
          end select
        end if
      case ChSound
        select case liste.inhalt(bed)
          case "legen"   : sound_spielen sound_legen
          case "mischen" : sound_spielen sound_misch
        end select
        soundGespielt = -1
      case ChWarten
        _Neuzeichnen = -1
        zeichne
        _Neuzeichnen = 0
        dim as string zeit = liste.inhalt(bed)
        sleep valint(zeit)
      case ChSpielende
        select case liste.inhalt(bed)
          case "sieg"
            if typ and ATypEnde then
              endevariante = iif(endevariante = EndeNeu, endeSiegUndNeu, endeSieg)
            else
              spielEnde EndeSieg
            end if
          case "verlust"
            if typ and ATypEnde then
              if endevariante = EndeSieg then endevariante = endeVerlust
            else
              spielEnde EndeVerlust
            end if
        end select
      end select
      bed = liste.naechster(bed)
    loop
    _Neuzeichnen = -1
    berechneTisch
    zeichne
    ' Wenn es bis hierher geschafft wurde, dann ist eine Aktion komplett abgearbeitet
    erfolgreich = -1
    if (*aktaktion).typ and ATypIrreversibel then backpunkte = 0
    if gelegt and (soundGespielt = 0) then sound_spielen sound_legen
    i = (*aktaktion).erfolg
  loop
  return erfolgreich
end function

function attribut(stapel as integer, attr as string, spec as string) as string
  ' gibt einen aktuellen Feld-Tag zurueck
  with feld(stapel)
    select case attr
      case ""             : return ""
      case "id"           : return trim(.id)
      case "var"          : return str(.variable)
      case "max"          : if .max = 209 then return "frei" else return str(.max)
      case "kartenzahl"   : return str(.anzKarten)
      case "wiederholung" : if .wiederholung = -1 then return "frei" else return str(.wiederholung)
      case "folgestart"
        if .startfarbe = -1 then return "frei"
        dim as string temp
        if .startfarbe > 0 then
          temp = farben(.startfarbe)
          if .startwert > 0 then temp &= " " & werte(.startwert)
        else
          if .startwert > 0 then temp &= werte(.startwert)
        end if
        return temp
      case "startfarbe"
        if .startfarbe = -1 then return "frei"
        if .startfarbe = 0 then return ""
        return farben(.startfarbe)
      case "startwert"
        if .startfarbe = -1 then return "frei"
        if .startwert = 0 then return ""
        return werte(.startwert)
      case "folgeende"    : if .endwert = 0 then return "" else return werte(.endwert)
      case "folgefarbe"  : return str(.folgefarbe)
      case "folgewert"   : return str(.folgewert)
      case "folgeschieb" : return str(.folgeschieb)
      case "einschub"    : return str(.einschub)
      case "fuellen"     : return str(.fuellen)
      case "rand"        : if .rand = 0 then return "nein" else return str(.rand)
      case "sichtbar"    : if .sichtbar = 209 then return "komplett" else return trim(str(.sichtbar))
      case "anzeige"
        dim as integer anzeige = liste.erster(.llastAnzeigen)
        do while anzeige <> 0
          if trim(liste.id(anzeige)) = spec then
            if left(liste.inhalt(anzeige), 1) = "X" then return "inaktiv" else return "aktiv"
          end if
          anzeige = liste.naechster(anzeige)
        loop
        return ""
      case "sperre"
        dim as integer sperre = liste.erster(.llastSperren)
        do while sperre <> 0
          if trim(liste.id(sperre)) = spec then
            if valint(liste.spec(sperre)) and SsInaktiv then return "inaktiv" else return "aktiv"
          end if
          sperre = liste.naechster(sperre)
        loop
        return ""
      case "schiebsperre"
        dim as integer sperre = liste.erster(.llastSchiebsperren)
        do while sperre <> 0
          if trim(liste.id(sperre)) = spec then
            if valint(liste.spec(sperre)) and SsInaktiv then return "inaktiv" else return "aktiv"
          end if
          sperre = liste.naechster(sperre)
        loop
      case "stopp"        : if .spezial and SStopp1 then return "ja" else return "nein"
      case "gestoppt"     : if .spezial and SStopp2 then return "ja" else return "nein"
      case "sicht"        : if .spezial and SVerdeckt then return "verdeckt" else return "offen"
      case "verdeckt"
        dim as integer kartennr = valint(spec) - 1
        if kartennr < 0 then kartennr = .anzKarten + kartennr
        if kartennr < 0 or kartennr >= .anzKarten then return ""
        if .karte(kartennr).status = Verdeckt then return "ja" else return "nein"
      case "status"
        if .anzkarten > 0 then
          dim as integer kartennr = valint(spec) - 1
          if kartennr < 0 then kartennr = .anzKarten + kartennr
          if kartennr < 0 or kartennr >= .anzKarten then return ""
          if .karte(kartennr).status = Verdeckt then return "verdeckt" else return "offen"
        else
          return "leer"
        end if
      case "gesperrt"     : if .spezial and SGesperrt then return "ja" else return "nein"
      case "auto"         : return .auto
      case "naechster"
        dim as integer wert = iif(.anzKarten = 0, 0, cint(.karte(.anzKarten-1).wert))
        select case .folgewert
          case "ab", "ab2" to "ab9"    : if len(.folgewert) = 3 then wert -= valint(right(.folgewert, 1)) else wert -= 1
          case "auf", "auf2" to "auf9" : if len(.folgewert) = 4 then wert += valint(right(.folgewert, 1)) else wert += 1
          case "x2"                    : wert = 2*wert
        end select
        return werte(((wert + 11) mod 13) + 2)
    end select
  end with
end function

sub ausgrauen(ziel as TypTisch)
  ' Grau-Faerbung eines Feldes an- oder ausschalten
  dim as integer z = ziel.stapel, graux, grauy, schieb, quer = 0
  dim as integer anzeigestart = iif(feld(z).sichtbar < feld(z).anzkarten, feld(z).anzKarten-feld(z).sichtbar, 0)
  if z = 0 then exit sub
  graux = feld(z).x
  grauy = feld(z).y
  schieb = feld(z).anzKarten - anzeigestart - 1
  if feld(z).eng < 1 orelse feld(z).anzKarten < feld(z).eng then schieb *= 2
  if feld(z).anzKarten > 0 then
    richtungsadd feld(z).richtung, graux, grauy, -schieb, schieb, -schieb, schieb
  end if
  if feld(ziel.stapel).spezial and SQuer then quer = 2*groesse
  dim as any ptr grau = imagecreate(4*groesse + quer, 6*groesse - quer, &h333333)
  put (graux*groesse, grauy*groesse), grau, xor
  imagedestroy grau
end sub

sub backup
  ' vorherigen Stand sichern (fuer Zugruecknahme)
  if stopp <> 0 then return
  for i as integer = 1 to anzFelder
    backfeld(i) = feld(i)
  next
  backpunkte = 1
end sub

sub berechneTisch
  ' Tischdaten (Kartenplazierungen) und Punktestand berechnen
  erase tisch
  redim as TypTisch tisch(maxX+3, maxY+5)
  dim as integer wert, quer, anzeigestart
  punkte = punktestart
  ' erst Leerfelder sowie Punkte berechnen
  for i as integer = anzFelder to 1 step -1
    if (feld(i).spezial and SQuer) = SQuer then quer = 2 else quer = 0
    if feld(i).anzkarten = 0 then
      if feld(i).x < 0 or feld(i).y < 0 then continue for
      for x as integer = feld(i).x to feld(i).x + 3 + quer
        for y as integer = feld(i).y to feld(i).y + 5 - quer
          if x > maxX + 3 or y > maxY + 5 then exit for
          tisch(x, y) = type<TypTisch>(i, 0)
        next
      next
    end if
    with feld(i)
      dim as integer bed = liste.erster(.llastPunkte)
      do while bed > 0
        select case liste.bedingung(bed)
          case "var" : punkte += val(liste.inhalt(bed))*.variable
          case "offen"
            for k as integer = 0 to .anzKarten - 1
              if .karte(k).status = Offen then punkte += val(liste.inhalt(bed))
            next
          case "kartenzahl", "": punkte += val(liste.inhalt(bed)) * .anzKarten
          case "belegt": if .anzKarten > 0 then punkte += val(liste.inhalt(bed))
          case "leer":   if .anzKarten = 0 then punkte += val(liste.inhalt(bed))
          case "karte"
            dim as integer farbe, wert, zaehl = 0
            let (farbe, wert) = kartenwertParse(liste.spec(bed))
            for i as integer = 0 to .anzKarten - 1
              if (farbe = 0 orelse farbe = .karte(i).farbe) andalso (wert = 0 orelse wert = .karte(i).wert) then zaehl += 1
            next
            punkte += val(liste.inhalt(bed)) * zaehl
          case "startfolge", "folge"
            if .anzKarten < 1 then exit select
            redim as TypKarte tkarte(0)
            dim as TypKarte temp = wert2karte(valint(liste.id(bed)))
            if liste.id(bed) = "-15" then temp = type<TypKarte>(.startfarbe, .startwert)
            tkarte(0) = .karte(0)
            dim as TypFeld tfeld = tempfeld(temp.farbe, temp.wert, .endwert, .folgefarbe, .folgewert, _
                                            .folgeschieb, .einschub, .max, .spezial, tkarte())
            dim as integer start = pruefeFolge(tfeld)
            if liste.bedingung(bed) = "startfolge" and start = 0 then exit select
            if start then punkte += val(liste.inhalt(bed))
            redim as TypKarte tkarte(1)
            dim as string spec = liste.spec(bed)
            dim as integer trenn = instr(spec, " ")
            dim as string ffarbe = left(spec, trenn-1), fwert = mid(spec, trenn+1)
            if ffarbe = "" then ffarbe = .folgefarbe
            if fwert = "" then fwert = .folgewert
            for k as integer = 1 to .anzKarten - 1
              tkarte(0) = .karte(k-1)
              tkarte(1) = .karte(k)
              tfeld = tempfeld(-1, 0, .endwert, ffarbe, fwert, .folgeschieb, .einschub, .max, .spezial, tkarte())
              if pruefeFolge(tfeld) then
                punkte += val(liste.inhalt(bed))
              else
                if liste.bedingung(bed) = "startfolge" then exit for
              end if
            next
        end select
        bed = liste.naechster(bed)
      loop
    end with
  next
  ' jetzt alle anderen
  for i as integer = anzFelder to 1 step -1
    with feld(i)
      dim as integer kx = .x, ky = .y
      if kx < 0 or ky < 0 or .sichtbar < 1 then continue for
      ' verdeckte entsperrte Karte aufdecken
      if .anzKarten > 0 andalso .karte(.anzKarten-1).status = Verdeckt andalso liste.erster(.llastSperren) > 0 then
        dim as integer aufdecken = pruefeSperre(i, SsNehmen)
        if aufdecken then .karte(.anzkarten-1).status = Offen : backpunkte = 0
      end if
      anzeigestart = iif(.sichtbar < .anzkarten, .anzKarten-.sichtbar, 0)
      for k as integer = anzeigestart to .anzKarten - 1
        quer = iif((.spezial and SQuer) = SQuer, 2, 0)
        for x as integer = kx to kx + 3 + quer
          for y as integer = ky to ky + 5 - quer
            if x > maxX + 3 or y > maxY + 5 then exit for
            tisch(x, y) = type<TypTisch>(i, k, .karte(k))
          next
        next
        if .eng > 0 andalso .anzKarten >= .eng then
          richtungsadd .richtung, kx, ky, -1, 1, -1, 1
        else
          richtungsadd .richtung, kx, ky, -2, 2, -2, 2
        end if
      next
    end with
  next
end sub

sub bewege(startfeld as TypTisch, zielstapel as integer, zielnr as integer = -1, _
           byval typ as integer = 0, byval anz as integer = 0)
  ' bewegt den Stapel ab startfeld optisch auf den zielstapel
  if animation = 0 orelse zielstapel < 0 or zielstapel > anzFelder then exit sub
  if zielnr < 0 or zielnr > feld(zielstapel).anzKarten then zielnr = feld(zielstapel).anzKarten
  if anz = 0 or anz > feld(startfeld.stapel).anzKarten - startfeld.nr then
    anz = feld(startfeld.stapel).anzKarten-startfeld.nr
  end if
  if anz < 1 then exit sub
  ' Ecken fuer den Zeichenbereich bestimmen
  dim as integer x = feld(startfeld.stapel).x*groesse, y = feld(startfeld.stapel).y*groesse, w = 4*groesse, h = 6*groesse
  dim as integer kx = 0, ky = 0, nx, ny, zx = feld(zielstapel).x*groesse, zy = feld(zielstapel).y*groesse
  dim as integer faktor = 2*groesse, faktor2 = 2*groesse, dist, status, anzeig1, anzeig2
  with feld(startfeld.stapel)
    anzeig1 = iif(.sichtbar < .anzkarten, .anzKarten-.sichtbar, 0)
  end with
  with feld(zielstapel)
    anzeig2 = iif(.sichtbar < .anzkarten, .anzKarten-.sichtbar, 0)
  end with
  if (feld(startfeld.stapel).spezial and SQuer) = SQuer then w = 6*groesse : h = 4*groesse
  if feld(startfeld.stapel).eng > 0 andalso feld(startfeld.stapel).anzKarten >= feld(startfeld.stapel).eng then _
     faktor = groesse
  if feld(zielstapel).eng > 0 andalso feld(zielstapel).anzKarten >= feld(zielstapel).eng then faktor2 = groesse
  richtungsadd feld(startfeld.stapel).richtung, x, y, _
      -faktor*(startfeld.nr-anzeig1), faktor*(startfeld.nr-anzeig1), _
      -faktor*(startfeld.nr-anzeig1), faktor*(startfeld.nr-anzeig1)
  if zielnr > 0 then richtungsadd feld(zielstapel).richtung, zx, zy, _
      -faktor2*(zielnr-anzeig2-1), faktor2*(zielnr-anzeig2-1), _
      -faktor2*(zielnr-anzeig2-1), faktor2*(zielnr-anzeig2-1)
  nx = x
  ny = y
  if (feld(startfeld.stapel).spezial and SQuer) = SQuer and (feld(zielstapel).spezial and SQuer) = 0 then
    if zx >= groesse then zx -= groesse
    if zx > (maxX-2)*groesse then zx = (maxX-2)*groesse
    zy += groesse
  elseif (feld(startfeld.stapel).spezial and SQuer) = 0 and (feld(zielstapel).spezial and SQuer) = SQuer then
    zx += groesse
    if zy > groesse then zy -= groesse
    if zy > maxY*groesse then zy = maxY*groesse
  end if
  dist = sqr((x-zx)^2 + (y-zy)^2) \ (1.5*groesse)
  ' temporaeres Bild und Ersatzspeicher erstellen
  dim as any ptr bild, ersatz
  if feld(startfeld.stapel).richtung and (RLinks or RRechts) then
    w += faktor*(anz-1)
    if feld(startfeld.stapel).richtung and RLinks then
      nx -= faktor*(feld(startfeld.stapel).anzKarten-startfeld.nr-1)
      kx = faktor*(feld(startfeld.stapel).anzKarten-startfeld.nr-1)
    end if
  end if
  if feld(startfeld.stapel).richtung and (ROben or RUnten) then
    h += faktor*(anz-1)
    if feld(startfeld.stapel).richtung and ROben then
      ny -= faktor*(feld(startfeld.stapel).anzKarten-startfeld.nr-1)
      ky = faktor*(feld(startfeld.stapel).anzKarten-startfeld.nr-1)
    end if
  end if
  bild = imagecreate(w, h, &hff00ff)
  ersatz = imagecreate(w, h)
  for i as integer = startfeld.nr to startfeld.nr + anz - 1
    if (typ and ChAniFrei) = ChAniVerdeckt then
      status = Verdeckt
    elseif (typ and ChAniFrei) = ChAniOffen then
      status = Offen
    elseif feld(startfeld.stapel).karte(i).status = Verdeckt or (feld(startfeld.stapel).spezial and SVerdeckt) then
      status = Verdeckt
    else
      status = Offen
    end if
    if (feld(startfeld.stapel).spezial and SQuer) = SQuer then
      if status = Verdeckt then
        put bild, (kx, ky), kartenbildQuer(53-((feld(startfeld.stapel).karte(i).spezial and Hintergrund2)=Hintergrund2)), pset
      else
        put bild, (kx, ky), kartenbildQuer(kartenwert(feld(startfeld.stapel).karte(i))), pset
      end if
    else
      if status = Verdeckt then
        put bild, (kx, ky), kartenbild(53-((feld(startfeld.stapel).karte(i).spezial and Hintergrund2)=Hintergrund2)), pset
      else
        put bild, (kx, ky), kartenbild(kartenwert(feld(startfeld.stapel).karte(i))), pset
      end if
    end if
    richtungsadd feld(startfeld.stapel).richtung, kx, ky, -faktor, faktor, -faktor, faktor
  next
  dim as TypKarte tempkarte(anz - 1)
  for i as integer = 0 to anz - 1
    swap feld(startfeld.stapel).karte(startfeld.nr + i), tempkarte(i)
  next
  zeichne -1
  dim as integer gx = nx, gy = ny
  if gx < 0 then gx = 0
  if gy < 0 then gy = 0
  if gx >= (maxX+4)*groesse - 1 then gx = (maxX+4)*groesse - 2
  if gy >= (maxY+6)*groesse - 1 then gy = (maxY+6)*groesse - 2
  if gx + w >= (maxX+4)*groesse then w = (maxX+4)*groesse - 1 - gx
  if gy + h >= (maxY+6)*groesse then h = (maxY+6)*groesse - 1 - gy
  get (gx, gy)-step(w-1, h-1), ersatz
  for i as integer = 1 to dist
    screenlock
    put (gx, gy), ersatz, pset
    gx = nx + (i*(zx - x))\dist
    gy = ny + (i*(zy - y))\dist
    if gx < 0 then gx = 0
    if gy < 0 then gy = 0
    if gx >= (maxX+4)*groesse - 1 then gx = (maxX+4)*groesse - 2
    if gy >= (maxY+6)*groesse - 1 then gy = (maxY+6)*groesse - 2
    if gx + w >= (maxX+4)*groesse then w = (maxX+4)*groesse - 1 - gx
    if gy + h >= (maxY+6)*groesse then h = (maxY+6)*groesse - 1 - gy
    get (gx, gy)-step(w-1, h-1), ersatz
    put (gx, gy), bild, (0, 0)-step(w-1, h-1), trans
    screenunlock
    sleep 10
  next
  put (gx, gy), bild, trans
  for i as integer = 0 to anz - 1
    swap feld(startfeld.stapel).karte(startfeld.nr + i), tempkarte(i)
  next
  imagedestroy bild
  imagedestroy ersatz
end sub

sub dupliziereListen(quelle as TypFeld, ziel as TypFeld)
  dim lst as integer
  lst = liste.erster(quelle.llastQuellen)
  ziel.llastQuellen = 0
  do while lst <> 0
    ziel.llastQuellen = listeAdd(ziel.llastQuellen, liste.position(lst))
    lst = liste.naechster(lst)
  loop
  lst = liste.erster(quelle.llastZiele)
  ziel.llastZiele = 0
  do while lst <> 0
    ziel.llastZiele = listeAdd(ziel.llastZiele, liste.position(lst))
    lst = liste.naechster(lst)
  loop
  lst = liste.erster(quelle.llastSperren)
  ziel.llastSperren = 0
  do while lst <> 0
    ziel.llastSperren = listeAdd(ziel.llastSperren, liste.position(lst))
    lst = liste.naechster(lst)
  loop
  lst = liste.erster(quelle.llastSchiebsperren)
  ziel.llastSchiebsperren = 0
  do while lst <> 0
    ziel.llastSchiebsperren = listeAdd(ziel.llastSchiebsperren, liste.position(lst))
    lst = liste.naechster(lst)
  loop
  lst = liste.erster(quelle.llastStopps)
  ziel.llastStopps = 0
  do while lst <> 0
    ziel.llastStopps = listeAdd(ziel.llastStopps, liste.position(lst))
    lst = liste.naechster(lst)
  loop
  lst = liste.erster(quelle.llastAnzeigen)
  ziel.llastAnzeigen = 0
  do while lst <> 0
    ziel.llastAnzeigen = listeAdd(ziel.llastAnzeigen, liste.position(lst))
    lst = liste.naechster(lst)
  loop
  lst = liste.erster(quelle.llastBeziehung)
  ziel.llastBeziehung = 0
  do while lst <> 0
    ziel.llastBeziehung = listeAdd(ziel.llastBeziehung, liste.position(lst))
    lst = liste.naechster(lst)
  loop
  lst = liste.erster(quelle.llastPunkte)
  ziel.llastPunkte = 0
  do while lst <> 0
    ziel.llastPunkte = listeAdd(ziel.llastPunkte, liste.position(lst))
    lst = liste.naechster(lst)
  loop
end sub

sub exitTest(taste as string)
  dim as integer speichern
  if taste <> chr(27) and taste <> chr(255, 107) then exit sub
  color &hffffff
  speichern = nachricht("Die Patience wurde nicht gelöst.\nWollen Sie das Spiel beenden?", "Ende\nSpeichern\nAbbruch")
  color 0
  if speichern = 1 then spielEnde EndeVerlust
  if speichern = 2 then spielSpeichern : spielEnde EndeSpeichern
end sub

sub feldInit(datei as string)
  ' Spiel laden
  dim as integer f = freefile, geladen = 0
  dim as string tempstring
  dim as integer speicherung = dir(pfad & "benutzer" & slash & spielername & slash & spieldatei & ".sav") <> ""
  if speicherung then
    geladen = spielLaden
    kill pfad & "benutzer" & slash & spielername & slash & spieldatei & ".sav"
  end if
  if geladen then
    setzeBildschirm
    redim preserve backfeld(1 to anzFelder)
    for i as integer = 1 to anzFelder
      if feld(i).spezial and SQuer then kartenWaag = -1 else kartenSenk = -1
    next
  else
    if open(pfad & "spiele" & slash & datei & ".xml" for input as #f) then
      open cons for output as #f
      print #f, EndeFileNotFound*&h10000
      close #f
      end
    end if
    dim as TypXML spiel = xmlParse(, f)
    close #f
    do while spiel.tag <> "spiel"
      if spiel.rest = "" then exit do
      spiel = xmlParse(spiel.rest, f)
      if inkey = chr(27) then exit do
    loop
    ' SCREENRES einstellen
    dim as string tempstring = spiel.GetAttr("fenster")
    if tempstring = "" then tempstring = "60x40"
    maxX = valint(tempstring)
    maxY = valint(mid(tempstring, instr(tempstring, "x")+1))
    maxX = iif(maxX < 32, 32, iif(maxX > 120, 120, maxX))
    maxY = iif(maxY < 20, 20, iif(maxY > 60, 60, maxY))
    setzeBildschirm
    spielname = spiel.GetAttr("name")
    ersetzeUmlaute spielname
    ' Spieldaten einlesen
    ersetzeUmlaute spiel.inhalt
    if speicherung then nachricht "Das gespeicherte Spiel ist\nnicht kompatibel zur aktuellen\nProgrammversion. Es wird nun\nein neues Spiel gestartet."
    feldInitParse spiel.inhalt
  end if
  ' nach dem Geben wird der Zufallsgenerator neu initialisiert
  ' dadurch bezieht sich eine Spielwiederholung nur auf das erste Geben
  randomize timer + 1
  dim as string fenstername = spielname
  ersetzeUmlaute fenstername, -1
  windowtitle "patfinder - " & fenstername
  color 0, BGC
  cls
  ' Kartenbilder laden
  dim as string r1 = ruecken, r2
  if fileexists("karten" & slash & "ruecken" & slash & ruecken & "_2.bmp") then r2 = r1 & "_2" else r2 = r1
  if rueckenVar = 1 then
    r2 = r1
  elseif rueckenVar = 2 then
    r1 = r2
  end if
  kartenbild(0) = imagecreate(4*groesse, 6*groesse, 0)
  kartenbild(53) = imagecreate(4*groesse, 6*groesse, 0)
  kartenbild(54) = imagecreate(4*groesse, 6*groesse, 0)
  kartenbild(55) = imagecreate(4*groesse, 6*groesse, 0)
  bload "karten" & slash & kartenbilder & slash & "leer.bmp", kartenbild(0)
  bload "karten" & slash & "ruecken" & slash & r1 & ".bmp", kartenbild(53)
  bload "karten" & slash & "ruecken" & slash & r2 & ".bmp", kartenbild(54)
  bload "karten" & slash & kartenbilder & slash & "joker.bmp", kartenbild(55)
  for i as integer = 0 to 51
    kartenbild(i+1) = imagecreate(4*groesse, 6*groesse, 0)
    bload "karten" & slash & kartenbilder & slash & lcase(trim(farben(i\13 + 1))) _
          & format(i mod 13 + 2, "00") & ".bmp", kartenbild(i+1)
  next
  if kartenWaag then
    for i as integer = 0 to 55
      kartenbildQuer(i) = imagecreate(6*groesse, 4*groesse, &hff00ff)
      for x as integer = 0 to 4*groesse - 1
        for y as integer = 0 to 6*groesse - 1
          pset kartenbildQuer(i), (y, 4*groesse - x - 1), point(x, y, kartenbild(i))
        next
      next
    next
  end if
  if kartenSenk = 0 then
    for i as integer = 0 to 55
      imagedestroy kartenbild(i)
    next
  end if
  ' Felder nacharbeiten (Feldangabe als folgestart)
  for i as integer = 1 to anzFelder
    if feld(i).folgestart <> "" then
      for k as integer = 1 to anzFelder
        if i = k then continue for
        if feld(k).id = " " & feld(i).folgestart & " " then feld(i).startfarbe = k : exit for
      next
    end if
    if feld(i).kuerzel < 33 or feld(i).kuerzel > 127 then feld(i).kuerzel = 88
  next
  ' Aktionen nacharbeiten (Verhaleten bei Erfolg/Misserfolg)
  for i as integer = 1 to anzAktionen
    with aktion(i)
      select case .erfstring
        case "", "ende"     : .erfolg = anzAktionen + 1
        case "anfang"       : .erfolg = 1
        case "naechste"     : .erfolg = i + 1
        case "wiederholung" : .erfolg = i
        case else
          for k as integer = 1 to anzAktionen
            if aktion(k).id = " " & .erfstring & " " then .erfolg = k : exit for
          next
      end select
      select case .misstring
        case "", "naechste" : .misserfolg = i + 1
        case "anfang"       : .misserfolg = 1
        case "wiederholung" : .misserfolg = i
        case "ende"         : .misserfolg = anzAktionen + 1
        case else
          for k as integer = 1 to anzAktionen
            if aktion(k).id = " " & .misstring & " " then .misserfolg = k : exit for
          next
      end select
    end with
  next
  for i as integer = 1 to anzAbschluss
    with abschluss(i)
      select case .erfstring
        case "", "ende"     : .erfolg = anzAbschluss + 1
        case "anfang"       : .erfolg = 1
        case "naechste"     : .erfolg = i + 1
        case "wiederholung" : .erfolg = i
        case else
          for k as integer = 1 to anzAbschluss
            if abschluss(k).id = " " & .erfstring & " " then .erfolg = k : exit for
          next
      end select
    end with
  next
  for i as integer = 1 to anzAbschluss
    with abschluss(i)
      select case .misstring
        case "", "naechste" : .misserfolg = i + 1
        case "anfang"       : .misserfolg = 1
        case "wiederholung" : .misserfolg = i
        case "ende"         : .misserfolg = anzAbschluss + 1
        case else
          for k as integer = 1 to anzAbschluss
            if abschluss(k).id = " " & .misstring & " " then .misserfolg = k : exit for
          next
      end select
    end with
  next
end sub

sub feldInitParse(xmlrest as string, tag as string = "")
  ' Unterfunktion von feldInit
  dim as TypXML xmltemp
  dim tempint as integer, tempstring as string
  select case tag
  case ""    ' Parsen auf unterster Ebene
    do while xmlrest <> ""
      xmltemp = xmlParse(xmlrest)
      with xmltemp
        ' Zufallsfarbe / -wert einsetzen
        .inhalt = parseVariablen(.inhalt)
        select case .tag
        case "regelwerk"
          dim regeltag as TypXML = xmlParse(.inhalt), regelid(8) as string, regeltext(8) as string, regelanz as integer = 0
          do while regeltag.tag <> "" and regelanz < 9
            if regeltag.tag = "regel" then
              regelid(regelanz) = regeltag.GetAttr("id")
              regeltext(regelanz) = regeltag.inhalt
              regelanz += 1
            end if
            regeltag = xmlParse(regeltag.rest)
          loop
          if regel > 0 and regel <= regelanz then
            spielregel = regelid(regel-1)
          else
            if regelanz = 1 then
              spielregel = regelid(0)
            elseif regelanz > 1 then
              dim as string text = " Druecken Sie eine Taste von 1 - " & regelanz & ", um eine Regel auszuwaehlen! "
              dim as integer eingabe = instrrev(text, " ", maxX * 1.25 - 2)
              if eingabe < 1 then eingabe = len(text)
              print : print " Es stehen mehrere Regeln zur Auswahl:" : print
              for i as integer = 1 to regelanz
                print " " & i & ") " & regeltext(i-1)
              next
              print : print left(text, eingabe-1) : print mid(text, eingabe) : print
              do
                eingabe = valint(input(1))
              loop until eingabe > 0 and eingabe <= regelanz
              spielregel = regelid(eingabe-1)
            end if
          end if
        case "regel"
          if .GetAttr("id") = spielregel then feldInitParse .inhalt
        case "level"
          if valint(.GetAttr("ab")) <= level then
            if .GetAttr("bis") = "" or valint(.GetAttr("bis")) >= level then feldInitParse .inhalt
          end if
        case "version"   : Spielversion = valint(.inhalt)
        case "bemerkung" : bemerkung = .inhalt
        case "anleitung" : anleitung = .inhalt
        case "karten"
          kartenset = valint(.inhalt)
          dim as integer setzahl
          if mid(.inhalt, len(.inhalt)-1, 1) = "x" then
            setzahl = valint(right(.inhalt, 1))
            if setzahl > 4 then setzahl = 4
          elseif (kartenset mod 52) = 0 and kartenset <= 208 then
            setzahl = kartenset\52
            kartenset = 52
          elseif (kartenset mod 32) = 0 and kartenset <= 128 then
            setzahl = kartenset\32
            kartenset = 32
          end if
          zufallsfarbe = int(rnd*4) + 1
          select case kartenset
            case 32
              for set as integer = 1 to setzahl
                for wert as integer = K7 to KA : for farbe as integer = Herz to Pik
                  stapel(anzKarten) = type<TypKarte>(farbe, wert)
                  if (setzahl mod 2) = 0 and (set mod 2) = 0 then stapel(anzKarten).spezial = Hintergrund2
                  anzKarten += 1
                next : next
              next
              zufallswert = int(rnd*8) + 7
            case 52
              for set as integer = 1 to setzahl
                for wert as integer = K2 to KA : for farbe as integer = Herz to Pik
                  stapel(anzKarten) = type<TypKarte>(farbe, wert)
                  if (setzahl mod 2) = 0 and (set mod 2) = 0 then stapel(anzKarten).spezial = Hintergrund2
                  anzKarten += 1
                next : next
              next
              zufallswert = int(rnd*13) + 2
          end select
          kartenset or= setzahl shl 8
        case "punktemax": punktemax = valint(.inhalt)
        case "punktestart": punktestart = valint(.inhalt)
        case "levelmax": if level > valint(.inhalt) then level = valint(.inhalt)
        case "add"
          if anzKarten < 208 then
            ' Karte(n) hinzufuegen
            dim as string farbstring, wertstring
            dim as integer farbe, wert, hintergrund = iif(.GetAttr("rueckseite") = "2", Hintergrund2, 0)
            if .inhalt = "Joker" then
              stapel(anzKarten) = type<TypKarte>(0, 0, 0, hintergrund or SJoker)
              anzKarten += 1              
              exit select
            end if
            if instr(.inhalt, " ") then
              farbstring = left(.inhalt, instr(.inhalt, " ") - 1)
              wertstring = mid(.inhalt, instr(.inhalt, " ") + 1)
            elseif len(.inhalt) < 3 or .inhalt = "zufallswert" then
              farbstring = ""
              wertstring = .inhalt
            else
              farbstring = .inhalt
              wertstring = ""
            end if
            ' zugehoerige Zahlenwerte suchen
            for farbe = 1 to 4
              if farben(farbe) = farbstring then exit for
            next
            for wert = 2 to 14
              if werte(wert) = wertstring then exit for
            next
            if farbe > 4 and wert > 14 then exit select
            ' und los ...
            dim as string typ = .GetAttr("typ")
            if typ = "einzel" then
              if farbe > 4 or wert > 14 then exit select
              stapel(anzKarten) = type<TypKarte>(farbe, wert, 0, hintergrund)
              anzKarten += 1
            elseif typ = "familie" then
              if farbe = 5 then   ' vier Karten eines Wertes hinzufuegen
                if anzKarten < 205 then
                  for i as integer = 1 to 4
                    stapel(anzKarten) = type<TypKarte>(i, wert, 0, hintergrund)
                    anzKarten += 1
                  next
                end if
              else                ' Kartenfolge einer Farbe hinzufuegen
                if anzKarten < 196 or ((kartenset and &hff) = 32 and anzKarten < 201) then
                  for i as integer = iif((kartenset and &hff) = 32, 7, 2) to 14
                    stapel(anzKarten) = type<TypKarte>(farbe, i, 0, hintergrund)
                    anzKarten += 1
                  next
                end if
              end if
            end if
          end if
        case "sub"
          ' Karte(n) entfernen
          dim as string farbstring, wertstring
          dim as integer farbe, wert, hintergrund
          select case .GetAttr("rueckseite")
            case "1"  : hintergrund = 1
            case "2"  : hintergrund = 2
            case else : hintergrund = 0
          end select
          if instr(.inhalt, " ") then
            farbstring = left(.inhalt, instr(.inhalt, " ") - 1)
            wertstring = mid(.inhalt, instr(.inhalt, " ") + 1)
          elseif len(.inhalt) = 1 or .inhalt = "zufallswert" then
            farbstring = ""
            wertstring = .inhalt
          else
            farbstring = .inhalt
            wertstring = ""
          end if
          ' zugehoerige Zahlenwerte suchen
          for farbe = 1 to 4
            if farben(farbe) = farbstring then exit for
          next
          for wert = 2 to 14
            if werte(wert) = wertstring then exit for
          next
          ' und los ...
          dim as string typ = .GetAttr("typ")
          if typ = "einzel" then
            for i as integer = 0 to anzKarten - 1
              if (hintergrund = 1 and stapel(i).spezial <> 0) or _
                 (hintergrund = 2 and stapel(i).spezial <> Hintergrund2) then continue for
              if stapel(i).farbe = farbe and stapel(i).wert = wert then
                stapel(i) = stapel(anzKarten - 1)
                anzKarten -= 1
                exit for
              end if
            next
          elseif typ = "familie" then
            if farbe = 5 then   ' vier Karten eines Wertes entfernen
              for farbe as integer = 1 to 4
                for i as integer = 0 to anzKarten - 1
                  if (hintergrund = 1 and stapel(i).spezial <> 0) or _
                     (hintergrund = 2 and stapel(i).spezial <> Hintergrund2) then continue for
                  if stapel(i).farbe = farbe and stapel(i).wert = wert then
                    stapel(i) = stapel(anzKarten - 1)
                    anzKarten -= 1
                    exit for
                  end if
                next
              next
            else                ' Kartenfolge einer Farbe entfernen
              for wert as integer = iif((kartenset and &hff) = 32, 7, 2) to 14
                for i as integer = 0 to anzKarten - 1
                  if (hintergrund = 1 and stapel(i).spezial <> 0) or _
                     (hintergrund = 2 and stapel(i).spezial <> Hintergrund2) then continue for
                  if stapel(i).farbe = farbe and stapel(i).wert = wert then
                    stapel(i) = stapel(anzKarten - 1)
                    anzKarten -= 1
                    exit for
                  end if
                next
              next
            end if
          end if
        case "markiere"
          dim as string tempstring = .GetAttr("farbe")
          select case .inhalt
            case "stopp": if tempstring <> "" then markStopp = valint("&h" & tempstring)
            case "korrekt": if tempstring = "" then markKorrekt = &h008800 else markKorrekt = valint("&h" & tempstring)
          end select
        case "vorlage"
          anzVorlagen += 1
          redim preserve vorlage(1 to anzVorlagen+1)
          dim as string typ = .GetAttr("typ")
          for i as integer = 1 to anzVorlagen - 1
            if typ = vorlage(i).felddaten.id then
              vorlage(anzVorlagen).felddaten = vorlage(i).felddaten
              vorlage(anzVorlagen).listenlaenge = vorlage(i).listenlaenge
              for k as integer = 0 to vorlage(i).listenlaenge - 1
                vorlage(anzVorlagen).legeliste(k) = vorlage(i).legeliste(k)
              next
              dupliziereListen vorlage(i).felddaten, vorlage(anzVorlagen).felddaten
              exit for
            end if
          next
          typ = .GetAttr("kuerzel")
          if len(typ) = 1 andalso typ[0] > 32 and typ[0] < 128 then vorlage(anzVorlagen).felddaten.kuerzel = typ[0]
          vorlage(anzVorlagen).felddaten.id = .GetAttr("id")
          vorlage(anzVorlagen).felddaten.sichtbar = 209
          vorlage(anzVorlagen).felddaten.sichtbarAnfang = 209
          feldInitParse .inhalt, "vorlage"
        case "feld"
          anzFelder += 1
          redim preserve feld(1 to anzFelder+1), backfeld(1 to anzFelder)
          dim as string typ = .GetAttr("typ")
          feld(anzFelder).sichtbar = 209
          feld(anzFelder).sichtbarAnfang = 209
          if typ = "stock" then
            with feld(anzFelder)            
              .kuerzel = asc("S")
              if Standardstock = 0 then Standardstock = anzFelder
              dim as integer zug
              do while anzKarten > 0
                zug = int(rnd*anzKarten)
                .karte(.anzkarten) = stapel(zug)
                stapel(zug) = stapel(anzKarten - 1)
                anzKarten -= 1
                .anfang(.anzKarten) = 0
                .anzKarten += 1
              loop
            end with
          else
            for i as integer = 1 to anzVorlagen
              if typ = vorlage(i).felddaten.id then
                feld(anzFelder) = vorlage(i).felddaten
                for k as integer = 0 to vorlage(i).listenlaenge - 1
                  initParseLegeSortiere(vorlage(i).legeliste(k), @feld(anzFelder))
                next
                dupliziereListen vorlage(i).felddaten, feld(anzFelder)
                exit for
              end if
            next
          end if
          typ = .GetAttr("kuerzel")
          if len(typ) = 1 andalso typ[0] > 32 and typ[0] < 128 then feld(anzFelder).kuerzel = typ[0]
          feld(anzFelder).id = " " & .GetAttr("id") & " "
          feld(anzFelder).x  = valint(.GetAttr("x"))
          feld(anzFelder).y  = valint(.GetAttr("y"))
          feldInitParse .inhalt, "feld"
          ' nachbearbeiten
          with feld(anzFelder)
            if .rand = -2 then if .eng*2 - 2 > .max then .rand = .eng-2 else .rand = .max-1
            if (.spezial and SQuer) = 0 then
              kartenSenk = -1
              ' Anpassung Maximum
              if feld(anzFelder).x > maxX then feld(anzFelder).x = maxX
              if feld(anzFelder).y > maxY then feld(anzFelder).y = maxY
            else
              if feld(anzFelder).x > maxX - 2 then feld(anzFelder).x = maxX - 2
              if feld(anzFelder).y > maxY + 2 then feld(anzFelder).y = maxY + 2
            end if
          end with
        case "aktion", "abschluss", "beginn", "ende"
          dim as TypAktion ptr aktaktion
          if .tag = "aktion" then
            anzAktionen += 1
            redim preserve aktion(1 to anzAktionen)
            aktaktion = @aktion(anzAktionen)
          else
            anzAbschluss += 1
            redim preserve abschluss(1 to anzAbschluss)
            aktaktion = @abschluss(anzAbschluss)
          end if
          (*aktaktion).id  = " " & .GetAttr("id") & " "
          if .tag = "beginn" then
            abschluss(anzAbschluss).typ = ATypBeginn
          elseif .tag = "ende" then
            select case .GetAttr("typ")
              case "sieg"    : abschluss(anzAbschluss).typ = ATypSieg
              case "verlust" : abschluss(anzAbschluss).typ = ATypVerlust
              case else      : abschluss(anzAbschluss).typ = ATypEnde
            end select
          else
            select case .GetAttr("typ")
              case "links"     : (*aktaktion).typ = ATypLinks
              case "rechts"    : (*aktaktion).typ = ATypRechts
              case "klick"     : (*aktaktion).typ = ATypKlick
              case "mitte"     : (*aktaktion).typ = ATypMitte
              case "legen"     : (*aktaktion).typ = ATypLegen
              case "frei"      : (*aktaktion).typ = ATypFrei
            end select
          end if
          if .GetAttr("ruecknahme") = "nein" then (*aktaktion).typ or= ATypIrreversibel
          feldInitParse .inhalt, .tag
        end select
      end with
      xmlrest = xmltemp.rest
    loop

  case "vorlage", "feld"   ' Parsen des <feld>-Tags
    dim feldptr as TypFeld ptr, feldanz as integer
    if tag = "vorlage" then
      feldanz = anzVorlagen
      feldptr = @vorlage(anzVorlagen).felddaten
    else
      feldanz = anzFelder
      feldptr = @feld(anzFelder)
    end if
    do while xmlrest <> ""
      xmltemp = xmlParse(xmlrest)
      xmltemp.inhalt = parseVariablen(xmltemp.inhalt)
      select case xmltemp.tag
        case "regel"
          if xmltemp.GetAttr("id") = spielregel then feldInitParse xmltemp.inhalt, .tag
        case "level"
          if valint(xmltemp.GetAttr("ab")) <= level then
            if xmltemp.GetAttr("bis") = "" or valint(xmltemp.GetAttr("bis")) >= level then
              feldInitParse xmltemp.inhalt, .tag
            end if
          end if
        case "max"
          if xmltemp.inhalt = "frei" then feldptr->max = 209 else feldptr->max = valint(xmltemp.inhalt)
        case "richtung"    : feldptr->richtung    = sucheRichtung(xmltemp.inhalt)
        case "folgestart"
          dim as string temp = xmltemp.GetAttr("bedingung")
          if temp = "belegt" or temp = "voll" or temp = "frei" then feldptr->folgestart = xmltemp.inhalt
          setzeAttribut feldptr, "folgestart", xmltemp.inhalt, temp
        case "folgeende"   : setzeAttribut feldptr, "folgeende", xmltemp.inhalt
        case "folgefarbe"  : feldptr->folgefarbe  = xmltemp.inhalt
        case "folgewert"   : feldptr->folgewert   = xmltemp.inhalt
        case "folgeschieb" : feldptr->folgeschieb = xmltemp.inhalt
        case "einschub"    : feldptr->einschub    = xmltemp.inhalt
        case "fuellen"     : setzeAttribut feldptr, "fuellen", xmltemp.inhalt
        case "eng"         : feldptr->eng         = valint(xmltemp.inhalt)
        case "sicht"       : if xmltemp.inhalt = "verdeckt" then feldptr->spezial or= SVerdeckt
        case "lage"        : if xmltemp.inhalt = "quer" then feldptr->spezial or= SQuer : kartenWaag = -1
        case "punkte"
          dim as integer farbewert = 0
          dim as string bedingung = xmltemp.GetAttr("bedingung")
          if bedingung = "startfolge" or bedingung="folge" then
            tempstring = xmltemp.GetAttr("start")
            if tempstring = "" then
              farbewert = karte2wert(type<TypKarte>(feldptr->startfarbe, feldptr->startwert))
            else
              farbewert = karte2wert(kartenwertParse(tempstring))
            end if
            tempstring = xmltemp.GetAttr("folgefarbe") & " " & xmltemp.GetAttr("folgewert")
          end if
          if bedingung = "karte" then tempstring = parseVariablen(xmltemp.GetAttr("karte"))
          feldptr->llastPunkte = listeAdd(feldptr->llastPunkte, ListPunkte, str(farbewert), xmltemp.inhalt, _
                                                 bedingung, tempstring)
        case "anzeige"
          dim as string typ = xmltemp.GetAttr("typ"), text = xmltemp.GetAttr("text"), inhalt
          select case typ
            case ""      : if text = "" then typ = "kartenzahl"
            case "farbe" : typ = "startfarbe"
            case "wert"  : typ = "startwert"
          end select
          inhalt =  iif(xmltemp.GetAttr("status") = "inaktiv", "X", "") & xmltemp.inhalt
          feldptr->llastAnzeigen = listeAdd(feldptr->llastAnzeigen, ListAnzeige, xmltemp.GetAttr("id"), inhalt, typ, text)
        case "rand"
          if xmltemp.inhalt = "nein" then
            feldptr->rand = -1
          elseif xmltemp.inhalt = "komplett" then
            feldptr->rand = -2
          elseif valint(xmltemp.inhalt) > 0 then
            feldptr->rand = valint(xmltemp.inhalt) - 1
          end if
        case "schiebsperre"
          dim as integer spec
          select case xmltemp.GetAttr("bedingung")
            case "leer"      : spec or= SsLeer
            case "belegt"    : spec or= SsBelegt
            case "stopp"     : spec or= SsStopp
            case "keinstopp" : spec or= SsKeinStopp
          end select
          if xmltemp.GetAttr("aktiv") = "nein" then spec or= SsInaktiv
          feldptr->llastSchiebsperren = listeAdd(feldptr->llastSchiebsperren, ListSchiebsperre, _
          " " & xmltemp.GetAttr("id") & " ", " " & xmltemp.inhalt & " ", xmltemp.GetAttr("bedingung"), str(spec))
          if xmltemp.GetAttr("status") = "inaktiv" then setzeAttribut feldptr, "schiebsperre", "inaktiv", xmltemp.GetAttr("id")
        case "quelle"
          feldptr->llastQuellen = listeAdd(feldptr->llastQuellen, ListQuelle, " " & xmltemp.GetAttr("id") & " ", _
               " " & xmltemp.inhalt & " ", xmltemp.GetAttr("bedingung"), xmltemp.GetAttr("pruefe"))
        case "ziel"
          dim as string bedingung = xmltemp.GetAttr("bedingung")
          if xmltemp.GetAttr("sicht") = "verdeckt" then
            bedingung = "v " & bedingung
          else
            bedingung = "o " & bedingung
          end if
          feldptr->llastZiele = listeAdd(feldptr->llastZiele, ListZiel, " " & xmltemp.GetAttr("id") & " ", _
               " " & xmltemp.inhalt & " ", bedingung, xmltemp.GetAttr("pruefe"))
        case "sperre"
          dim as integer spec
          select case xmltemp.GetAttr("typ")
            case "legen"    : spec = SsLegen
            case "nehmen"   : spec = SsNehmen
            case else       : spec = SsNehmen or SsLegen
          end select
          select case xmltemp.GetAttr("bedingung")
            case "leer"     : spec or= SsLeer
            case "belegbar" : spec or= SsBelegbar
            case "voll"     : spec or= SsVoll
            case else       : spec or= SsBelegt
          end select
          select case xmltemp.GetAttr("modus")
            case "and"      : spec or= MAnd
            case "xor"      : spec or= MXor
          end select
          if xmltemp.GetAttr("aktiv") = "nein" then spec or= SsInaktiv
          feldptr->llastSperren = listeAdd(feldptr->llastSperren, ListSperre, " " & xmltemp.GetAttr("id") & " ", _
               " " & xmltemp.inhalt & " ", xmltemp.GetAttr("bedingung"), str(spec))
          if xmltemp.GetAttr("status") = "inaktiv" then setzeAttribut feldptr, "sperre", "inaktiv", xmltemp.GetAttr("id")
        case "stopp"
          feldptr->llastStopps = listeAdd(feldptr->llastStopps, ListStopp, " " & xmltemp.GetAttr("id") & " ", _
               xmltemp.inhalt, xmltemp.GetAttr("bedingung"), xmltemp.GetAttr("spec"))
        case "beziehung"
          feldptr->llastBeziehung = listeAdd(feldptr->llastBeziehung, ListBeziehung, " " & xmltemp.GetAttr("id") & " ", _
               xmltemp.inhalt, "", "")
        case "wiederholung"
          if xmltemp.inhalt = "frei" then
            feldptr->wiederholung = -1
          else
            feldptr->wiederholung = valint(xmltemp.inhalt)
          end if
          if xmltemp.GetAttr("aufnahme") = "sprung" then feldptr->spezial or= SSprung
          if xmltemp.GetAttr("mischen") = "ja" then feldptr->spezial or= SMischen
        case "auto" : setzeAttribut feldptr, "auto", xmltemp.inhalt
        case "gesperrt" : if xmltemp.inhalt = "ja" then feldptr->spezial or= SGesperrt
        case "var"
          feldptr->variable = valint(xmltemp.inhalt)
          if feldptr->variable < 0 then feldptr->variable = 0
        case "sichtbar"
          setzeAttribut feldptr, "sichtbar", xmltemp.inhalt
          feldptr->sichtbarAnfang = feldptr->sichtbar
        case "lege", "sortiere"
          if tag = "vorlage" then
            vorlage(anzVorlagen).legeliste(vorlage(anzVorlagen).listenlaenge) = xmltemp
            vorlage(anzVorlagen).listenlaenge += 1
          else
            initParseLegeSortiere(xmltemp, feldptr)
          end if
      end select
      xmlrest = xmltemp.rest
    loop

  case "aktion", "abschluss", "beginn", "ende"
    do while xmlrest <> ""
      xmltemp = xmlParse(xmlrest)
      xmltemp.inhalt = parseVariablen(xmltemp.inhalt)
      dim as TypAktion ptr temp
      if tag = "aktion" then temp = @aktion(anzAktionen) else temp = @abschluss(anzAbschluss)
      with *temp
        select case xmltemp.tag
          case "regel"
            if xmltemp.GetAttr("id") = spielregel then feldInitParse xmltemp.inhalt, "aktion"
          case "level"
            if valint(xmltemp.GetAttr("ab")) <= level then
              if xmltemp.GetAttr("bis") = "" or valint(xmltemp.GetAttr("bis")) >= level then
                feldInitParse xmltemp.inhalt, "aktion"
              end if
            end if
          case "bedingung"
            dim tag as string = xmltemp.GetAttr("tag"), inhalt as string = xmltemp.inhalt, spec as integer = 0
            select case xmltemp.GetAttr("beziehung")
              case "kleiner"        : spec or= VKleiner
              case "kleinergleich"  : spec or= VKleiner or VGleich
              case "groesser"       : spec or= VGroesser
              case "groessergleich" : spec or= VGroesser or VGleich
              case "ungleich"       : spec or= VKleiner or VGroesser
              case else             : spec or= VGleich
            end select
            if tag = "karte" then
              select case xmltemp.GetAttr("bedingung")
                case "leer"     : spec or= SsLeer
                case "belegt"   : spec or= SsBelegt
                case "belegbar" : spec or= SsBelegbar
                case "voll"     : spec or= SsVoll
              end select
            end if
            select case xmltemp.GetAttr("umschichten")
              case "auf" : spec or= ChUmschichtenAuf
              case "ab" : spec or= ChUmschichtenAb
            end select
            dim as string specwert
            select case tag
              case "startfolge"      : specwert = xmltemp.GetAttr("folge")
              case "karte"           : specwert = hex(spec, 4) & hex(valint(xmltemp.GetAttr("karte")), 4)
              case "sicht", "status" : specwert = xmltemp.GetAttr("karte")
              case "sperre", "schiebsperre", "anzeige" : specwert = xmltemp.GetAttr("id")
              case else              : specwert = str(spec)
            end select
            .llastBedingung = listeAdd(.llastBedingung, ListBedingung, " " & xmltemp.GetAttr("feld") & " ", _
                xmltemp.inhalt, tag, specwert)
          case "vergleich"
            dim typ as string = xmltemp.GetAttr("typ"), spec as integer = valint(xmltemp.inhalt)
            if spec < 0 then spec = 0
            if spec > 29 then spec = 29
            if typ = "farbe" then
              select case xmltemp.inhalt
                case "ungleich"       : spec = VFarbungleich
                case "wechsel"        : spec = VFarbwechsel
                case "keinwechsel"    : spec = VFarbSR
                case else             : spec = VFarbgleich
              end select
            elseif typ = "wert" then
              select case xmltemp.inhalt
                case "kleiner"        : spec = VKleiner
                case "kleinergleich"  : spec = VGleich or VKleiner
                case "groesser"       : spec = VGroesser
                case "groessergleich" : spec = VGleich or VGroesser
                case "ungleich  "     : spec = VKleiner or VGroesser
                case else             : spec = VGleich
              end select
            else
              select case xmltemp.GetAttr("beziehung")
                case "kleiner"        : spec or= VKleiner
                case "kleinergleich"  : spec or= VKleiner or VGleich
                case "groesser"       : spec or= VGroesser
                case "groessergleich" : spec or= VGroesser or VGleich
                case "ungleich"       : spec or= VKleiner or VGroesser
                case else             : spec or= VGleich
              end select
            end if
            .llastVergleich = listeAdd(.llastVergleich, ListVergleich, " " & xmltemp.GetAttr("feld1") & " ", _
                 " " & xmltemp.GetAttr("feld2") & " ", xmltemp.GetAttr("typ"), str(spec))
          case "aenderung"
            dim spec as integer = ChAenderung, tag as string = xmltemp.GetAttr("tag")
            if instr(tag, " ") then exit select
            select case xmltemp.GetAttr("ziel")
              case "id"       : spec or= ChID
              case "komplett" : spec or= ChKomplett ' TODO: noch umzusetzen
              case else       : spec or= ChEinzel
            end select
            if xmltemp.GetAttr("opt") = "tausch" then spec or= ChTausch
            select case tag
              case "status" : tag &= " " & xmltemp.GetAttr("karte")
              case "sperre", "schiebsperre", "anzeige" : tag &= " " & xmltemp.GetAttr("id")
            end select
            .llastAenderung = listeAdd(.llastAenderung, ListAenderung, " " & xmltemp.GetAttr("feld") & " ", _
                 xmltemp.inhalt, tag, str(spec))
          case "lege"
            dim as integer spec = ChLegen
            dim as short bed2= valint(xmltemp.GetAttr("startpos")), bed3 = valint(xmltemp.GetAttr("zielpos"))
            dim beding as string*12, anz as string = xmltemp.GetAttr("anz")
            if anz = "legezahl" then
              beding = "lege" & hex(bed2, 4) & hex(bed3, 4)
            else
              beding = hex(valint(anz), 4) & hex(bed2, 4) & hex(bed3, 4)
            end if
            select case xmltemp.GetAttr("ziel")
              case "id"       : spec or= ChID
              case "komplett" : spec or= ChKomplett
              case else       : spec or= ChEinzel
            end select
            select case xmltemp.GetAttr("richtung")
              case "rueckwaerts" : spec or= ChLegeRueckwaerts
              case "mischen"     : spec or= ChLegeMischen
              case "zufall"      : spec or= ChLegeZufall
            end select
            select case xmltemp.GetAttr("einschub")
              case "hinten" : spec or= ChEinschubHinten
              case "zufall" : spec or= ChEinschubZufall
            end select
            select case xmltemp.GetAttr("umschichten")
              case "auf" : spec or= ChUmschichtenAuf
              case "ab"  : spec or= ChUmschichtenAb
            end select
            select case xmltemp.GetAttr("typ")
              case "offen"    : spec or= ChOffen
              case "verdeckt" : spec or= ChVerdeckt
            end select
            select case xmltemp.GetAttr("animation")
              case "offen"    : spec or= ChAniOffen
              case "verdeckt" : spec or= ChAniVerdeckt
              case "ja"       : spec or= ChAniFrei
            end select
            dim optrest as string = xmltemp.GetAttr("opt"), opt as string, trenn as integer
            do while optrest <> ""
              trenn = instr(optrest, ",")
              if trenn then
                opt = left(optrest, trenn-1)
                optrest = mid(optrest, trenn+1)
              else
                opt = trim(optrest)
                optrest = ""
              end if
              if opt = "tausch" then spec or= ChTausch or ChLegeEinmal
              if opt = "erlaubt" then spec or= ChErlaubt
              if opt = "einmal" then spec or=ChLegeEinmal
            loop
            .llastAenderung = listeAdd(.llastAenderung, ListAenderung, " " & xmltemp.GetAttr("feld") & " ", _
                 " " & xmltemp.inhalt & " ", beding, str(spec))
          case "sound"
            .llastAenderung = listeAdd(.llastAenderung, ListAenderung, "", xmltemp.inhalt, "", str(ChSound))
          case "meldung"
            dim as string antwort = xmltemp.GetAttr("antwort")
            if antwort = "" then antwort = " OK "
            .llastAenderung = listeAdd(.llastAenderung, ListAenderung, " " & xmltemp.GetAttr("feld") & " ", _
                 xmltemp.inhalt, antwort, str(ChMeldung))
          case "warte"
            .llastAenderung = listeAdd(.llastAenderung, ListAenderung, "", xmltemp.inhalt, "", str(ChWarten))
          case "spielende"
            .llastAenderung = listeAdd(.llastAenderung, ListAenderung, "", xmltemp.inhalt, "", str(ChSpielende))
          case "erfolg"     : .erfstring = xmltemp.inhalt
          case "misserfolg" : .misstring = xmltemp.inhalt
        end select
      end with
      xmlrest = xmltemp.rest
    loop
  end select
end sub

sub initParseLegeSortiere(xml as TypXML, feldptr as TypFeld ptr)
  select case xml.tag
    case "lege"
      dim as integer legeanz = 1
      if xml.GetAttr("anz") <> "" then legeanz = valint(xml.GetAttr("anz"))
      dim as string quelle = xml.GetAttr("quelle"), bedingung = xml.GetAttr("bedingung")
      dim as integer farbe, wert
      let (farbe, wert) = kartenwertParse(xml.inhalt)
      if farbe = 0 then farbe = feldptr->startfarbe
      if wert = 0 then wert = feldptr->startwert
      for nr as integer = 1 to legeanz
        for i as integer = 1 to anzFelder
          if trim(feld(i).id) = quelle then
            for k as integer = feld(i).anzKarten - 1 to 0 step -1
              if xml.inhalt = "frei" or xml.inhalt = trim(farben(feld(i).karte(k).farbe)) or _
                 xml.inhalt = trim(werte(feld(i).karte(k).wert)) or _
                 xml.inhalt = trim(farben(feld(i).karte(k).farbe)) & " " & trim(werte(feld(i).karte(k).wert)) then
                if bedingung = "erlaubt" then
                  if xml.inhalt <> "frei" and (feldptr->startfarbe <> farbe or _
                     feldptr->startwert <> wert) then continue for
                elseif bedingung = "leer" then
                  if feldptr->anzKarten > 0 then continue for
                elseif bedingung = "belegt" then
                  if feldptr->anzKarten = 0 then continue for
                end if
                feldptr->karte(feldptr->anzKarten) = feld(i).karte(k)
                if xml.GetAttr("typ") = "verdeckt" then
                  feldptr->karte(feldptr->anzKarten).status = Verdeckt
                  feldptr->anfang(feldptr->anzKarten) = 1
                else
                  feldptr->karte(feldptr->anzKarten).status = Offen
                  feldptr->anfang(feldptr->anzKarten) = 0
                end if
                feldptr->anzKarten += 1
                for l as integer = k + 1 to feld(i).anzKarten
                  feld(i).karte(l-1) = feld(i).karte(l)
                next
                feld(i).anzKarten -= 1
                feld(i).karte(feld(i).anzKarten) = type<TypKarte>(0, 0, 0, 0)
                exit for
              end if
            next
            exit for
          end if
        next
      next
    case "sortiere"
      dim neuerplatz as integer, richtung as string = xml.GetAttr("richtung")
      if richtung = "hinten" then
        neuerplatz = 0
      elseif richtung = "vorn" then
        neuerplatz = feldptr->anzKarten - 1
      end if
      if richtung = "mischen" then
        for m as integer = 0 to feldptr->anzKarten - 1
          for n as integer = m + 1 to feldptr->anzKarten - 1
            if rnd*(n-m+1) < 1 then swap feldptr->karte(m), feldptr->karte(n)
          next
        next
      elseif richtung = "umdrehen" then
        for m as integer = 0 to feldptr->anzKarten \ 2 - 1
          swap feldptr->karte(m), feldptr->karte(feldptr->anzKarten - 1 - m)
        next
      else
        for i as integer = 0 to feldptr->anzKarten - 1
          if xml.inhalt = "frei" or xml.inhalt = trim(farben(feldptr->karte(i).farbe)) or _
             xml.inhalt = trim(werte(feldptr->karte(i).wert)) or _
             xml.inhalt = trim(farben(feldptr->karte(i).farbe)) & " " _
                              & trim(werte(feldptr->karte(i).wert)) then
            select case richtung
              case "aussen": if rnd < .5 then neuerplatz = 0 else neuerplatz = feldptr->anzKarten - 1
              case "innen":  if feldptr->anzKarten > 2 then neuerplatz = int(rnd*(feldptr->anzKarten-2))+1
              case "zufall": neuerplatz = int(rnd*feldptr->anzKarten)
            end select
            dim as integer schritt = iif(neuerplatz > i, 1, -1)
            dim as TypKarte tempkarte = feldptr->karte(i)
            for k as integer = i to neuerplatz - schritt step schritt
              feldptr->karte(k) = feldptr->karte(k+schritt)
            next
            feldptr->karte(neuerplatz) = tempkarte
          end if
        next
      end if
  end select
end sub

function findeFeld(xx as integer, yy as integer) as TypTisch
  ' findet das Feld, das am besten zu den angegebenen Koordinaten passt
  dim as integer x = xx\groesse, y = yy\groesse
  dim as TypTisch ret = type<TypTisch>(0, 0)
  if x < 1 or y < 1 or x > maxX + 2 or y > maxY + 4 then return ret
  if tisch(x, y).stapel > 0 then return tisch(x, y)
  for i as integer = 0 to 3
    if ret.stapel = 0 then
      ret = tisch(x + (i mod 2)*2 - 1, y + (i < 2)*2 + 1)
    elseif ret.stapel <> tisch(x + (i mod 2)*2 - 1, y + (i < 2)*2 + 1).stapel then
      if tisch(x + (i mod 2)*2 - 1, y + (i < 2)*2 + 1).stapel <> 0 then return type<TypTisch>(0, 0)
    end if
  next
  return ret
end function

sub hilfe
  ' Spielanleitung anzeigen
  dim as integer such, x, y, tx, ty, quer, rechtsrand, farbe, anzeigemax
  dim as string tempstring, anzeige
  cls
  line (20, 20)-step((maxX+2)*(groesse\2), (maxY+4)*(groesse\2)),, b
  for i as integer = anzFelder to 1 step -1
    x = feld(i).x
    y = feld(i).y
    if .feld(i).spezial and SQuer then quer = 1 else quer = 0
    anzeigemax = iif(feld(i).anfangskarten(0) > feld(i).max, feld(i).max, feld(i).anfangsKarten(0))
    for k as integer = 0 to anzeigemax - 1
      if feld(i).sichtbarAnfang <= k then exit for
      if x >= 0 then
        line (x*(groesse\2) + quer*(groesse\4) + 20, y*(groesse\2) + (1-quer)*(groesse\4) + 20) _
             -step(groesse + quer*(groesse\2), (3 - quer)*(groesse/2)),, b
        line (x*(groesse\2) + quer*(groesse\4) + 21, y*(groesse\2) + (1-quer)*(groesse\4) + + 21) _
             -step(groesse + quer*(groesse\2) - 2, (3 - quer)*(groesse/2) - 2), _
             iif(feld(i).anfang(k) = 1, &h999999, BGC), bf
      end if
      if k < anzeigemax - 1 and k < feld(i).sichtbarAnfang - 1 then
        if feld(i).eng > 0 andalso anzeigemax >= feld(i).eng then
          richtungsadd feld(i).richtung, x, y, -1, 1, -1, 1
        else
          richtungsadd feld(i).richtung, x, y, -2, 2, -2, 2
        end if
      end if
    next
    if x >= 0 and y >= 0 and feld(i).sichtbarAnfang > 0 then
      tx = (x+1)*(groesse\2) + quer*(groesse\2) + 17
      ty = (y+1)*(groesse\2) + (1-quer)*(groesse\2) + 17
      draw string (tx, ty), chr(feld(i).kuerzel)
    end if
  next
  y = 6*groesse
  x = maxX*groesse\2 + 5*groesse
  rechtsrand = .625*maxX - 3
  draw string (x, 40), spielname
  tempstring = bemerkung & "\n"
  do while tempstring <> ""
    such = instr(tempstring, "\n")
    if such = 0 or such > rechtsrand then such = - instrrev(tempstring, " ", rechtsrand)
    if such = 0 then such = len(tempstring)
    anzeige = left(tempstring, abs(such)-1)
    draw string (x, y), anzeige, 0
    if such > 0 then
      tempstring = mid(tempstring, such+2)
    else
      tempstring = mid(tempstring, -such+1)
    end if
    y += groesse
  loop
  y = maxY*(groesse\2) + 7*groesse
  x = 2*groesse
  rechtsrand = groesse*0.125*maxX
  tempstring = anleitung & "\n"
  do while tempstring <> ""
    such = instr(tempstring, "\n")
    if such = 0 or such > rechtsrand then such = - instrrev(tempstring, " ", rechtsrand)
    if such = 0 then such = len(tempstring)
    anzeige = left(tempstring, abs(such)-1)
    draw string (x, y), anzeige, 0
    if such > 0 then
      tempstring = mid(tempstring, such+2)
      y += 2*groesse
    else
      tempstring = mid(tempstring, -such+1)
      y += groesse
    end if
  loop
  getkey
  zeichne
end sub

function karte2wert(k as TypKarte) as integer
  ' gibt Kartenfarbe und -wert als einzelnes Integer zurueck
  if k.spezial and SJoker then return 57
  if k.farbe = -1 then return -15
  dim as integer ret = k.farbe*14 + k.wert - 15
  if ret < -15 or ret > 55 then ret = 0
  return ret
end function

function kartenwert(k as TypKarte) as integer
  ' gibt die Bildnummer einer Karte zurueck
  if k.spezial and SJoker then return 55
  dim as integer ret = k.farbe*13 + k.wert - 14
  if ret < 0 or ret > 52 then ret = 0
  return ret
end function

function kartenwertParse(inhalt as string) as TypKarte
  dim as integer leerzeichen = instr(inhalt, " "), farbe = 0, wert = 0
  for i as integer = 1 to 4
    if leerzeichen = 0 then
      if farben(i) = inhalt then farbe = i
    else
      if farben(i) = left(inhalt, leerzeichen - 1) then farbe = i
    end if
  next
  for i as integer = 2 to 14
    if werte(i) = mid(inhalt, leerzeichen + 1) then wert = i
  next
  return type<TypKarte>(farbe, wert, 0, 0)
end function

function legeversuch(start as TypTisch, ziel as TypTisch, legen as integer = -1, _
                     richtung as integer = 1, aktion as integer = -1, stockauf as integer = 0, _
                     anz as integer = 0) as integer
  ' prueft, ob das Legen moeglich ist, und legt in diesem Fall (ausser legen = 0)
  ' allgemeine Abbruchbedingungen
  if ziel.stapel = 0 or ziel.stapel = start.stapel then return 0
  if stopp and SStopp2 andalso (feld(ziel.stapel).spezial and SStopp2) = 0 then return 0
  if feld(start.stapel).anzKarten < 1 then return 0
  if pruefeSperre(ziel.stapel, SsLegen, start.stapel) = 0 then return 0
  if richtung = 1 then
    if aktion = -1 then
      dim as integer aktionstest = aktionslauf(ATypLegen, ziel, start, legen)
      if aktionstest <> 0 then return aktionstest
    end if
    if feld(start.stapel).folgeschieb = "nein" and start.nr < feld(start.stapel).anzKarten - 1 then return 0
    if feld(start.stapel).folgeschieb = "umdrehen" then return legeversuch(start, ziel, legen, -1, aktion, stockauf)
  end if
  ' Zielstapel ist fuer den Startstapel gesperrt
  dim as integer bed = liste.erster(feld(start.stapel).llastSchiebsperren)
  do while bed <> 0
    if (valint(liste.spec(bed)) and SsInaktiv) = 0 andalso instr(liste.inhalt(bed), feld(ziel.stapel).id) then
      select case valint(liste.spec(bed)) and SsSumme
        case 0 : return 0
        case SsLeer
          if feld(ziel.stapel).anzKarten > 0 then return 0
          if feld(start.stapel).anzKarten - start.nr > 1 then return 0
        case SsBelegt    : if feld(ziel.stapel).anzKarten < 1 then return 0
        case SsStopp     : if (feld(start.stapel).spezial and (SStopp1 or SStopp2)) = 0 then return 0
        case SsKeinStopp : if feld(start.stapel).spezial and (SStopp1 or SStopp2) then return 0
      end select
    end if
    bed = liste.naechster(bed)
  loop
  with feld(ziel.stapel)
    ' spezieller Folgestart: Anfangskarte muss besondere Bedingung erfuellen
    if .anzKarten > 0 then
      select case .spezial and (SFarbstart or SWertstart)
        case SFarbstart
          if .karte(0).farbe <> .startfarbe then return 0
        case SWertstart
          if .karte(0).wert <> .startwert then return 0
        case SFarbstart or SWertstart
          if .karte(0).farbe <> .startfarbe or .karte(0).wert <> .startwert then return 0
      end select
    end if
    ' weiter mit normalem Legen
    select case .einschub
      ' Einschubstelle festlegen
      case "", "vorn"
        ziel.nr = .anzKarten
        if .anzKarten > 0 then
          ziel.karte = type<TypKarte>(.karte(.anzKarten-1))
        end if
      case "hinten"
        with feld(ziel.stapel)
          if .startfarbe <> -1 andalso ((.startfarbe <> 0 andalso .startfarbe <> start.karte.farbe) orelse _
             (.startwert <> 0 andalso .startwert <> start.karte.wert)) then return 0
          ziel.nr = 0
          ziel.karte = type<TypKarte>(.karte(0))
        end with
      case "aussen"
        if ziel.nr > 0 and ziel.nr < .anzKarten - 1 then return 0
        if ziel.nr = .anzKarten - 1 then
          ziel.nr = .anzKarten
          if .anzKarten > 0 then
            ziel.karte = type<TypKarte>(.karte(.anzKarten-1))
          end if
        end if
      case else
        ' versuche an festgelegter Stelle einzuschieben
        ziel.nr = valint(.einschub)
        if ziel.nr > 0 then
          ziel.nr -= 1
        else
          ziel.nr = .anzKarten+ziel.nr-1
          if ziel.nr < 0 then ziel.nr = 0
        end if
        ziel.karte = type<TypKarte>(.karte(ziel.nr))
    end select
    ' Folgestart von anderem Feld abhaengig
    if .spezial and SBelegt then
      if feld(.startfarbe).anzKarten = 0 then return 0
    elseif .spezial and SVoll then
      if feld(.startfarbe).anzKarten < feld(.startfarbe).max then return 0
    end if
    ' zu pruefende Folge erstellen
    dim as integer tplus = 0, sfarbe = feld(ziel.stapel).startfarbe, swert = feld(ziel.stapel).startwert
    if ziel.nr > 0 or (feld(ziel.stapel).spezial and (SBelegt or SVoll or SFrei)) <> 0 then tplus = 1
    dim as integer tkartenzahl
    if ziel.nr = 0 andalso feld(start.stapel).folgeschieb = "frei" or feld(start.stapel).folgeschieb = "offen" _
                   andalso .folgeschieb = "frei" or .folgeschieb = "offen" then
      tkartenzahl = 1
    elseif anz = 0 or anz > feld(start.stapel).anzKarten - start.nr + tplus then
      tkartenzahl = feld(start.stapel).anzKarten - start.nr + tplus
    else
      tkartenzahl = anz + tplus
    end if
    if tkartenzahl < 1 then return 0
    if feld(start.stapel).folgeschieb = "einzeln" then tkartenzahl = tplus + 1
    if feld(ziel.stapel).anzKarten + tkartenzahl - tplus > feld(ziel.stapel).max then return 0
    dim as TypKarte tkarte(tkartenzahl - 1)
    if ziel.nr > 0 then
      tkarte(0) = .karte(.anzKarten - 1)
      sfarbe = -1
      swert = 0
    elseif (.spezial and SBelegt) or (.spezial and SVoll) or (.spezial and SFrei) then
      tkarte(0) = feld(.startfarbe).karte(feld(.startfarbe).anzKarten - 1)
      sfarbe = -1
      swert = 0
    end if
    for i as integer = tplus to tkartenzahl - 1
      if richtung = 1 then
        tkarte(i) = feld(start.stapel).karte(start.nr + i - tplus)
      else
        tkarte(tkartenzahl - 1 + tplus - i) = feld(start.stapel).karte(start.nr + i - tplus)
      end if
    next
    dim as string ffarbe = .folgefarbe, fwert = .folgewert
    if .folgeschieb = "offen" andalso tplus = 0 then ffarbe = "frei" : fwert = "frei"
    dim as TypFeld tfeld = tempfeld(sfarbe, swert, .endwert, ffarbe, fwert, _
                                    .folgeschieb, .einschub, .max, .spezial, tkarte())
  end with
  dim as integer legbar = pruefeFolge(tfeld)
  if legbar = 0 then
    ' Versuch, rueckwaerts zu legen
    if richtung = 1 then
      if feld(start.stapel).folgeschieb <> "frei" and feld(start.stapel).folgeschieb <> "offen" then _
         return legeversuch(start, ziel, legen, -1, aktion, stockauf) else return 0
    else
      return 0
    end if
  end if
  if legen then
    backup
    lege start, ziel, richtung,, stockauf, anz
  end if
  return -1
end function

sub lege(start as TypTisch, ziel as TypTisch, richtung as integer = 1, einschubstopp as integer = -1, _
         stockauf as integer = 0, byval anz as integer = 0)
  ' legt einen Kartenstapel ohne Ueberpruefung auf Kartenzahl oder passende Karten
  if start.nr < 0 or ziel.nr < 0 then exit sub
  start.karte = type<TypKarte>(feld(start.stapel).karte(start.nr).farbe, feld(start.stapel).karte(start.nr).wert, _
                feld(start.stapel).karte(start.nr).status, feld(start.stapel).karte(start.nr).spezial)
  ' weiter mit normalem Legen
  dim as string startrichtung = feld(start.stapel).folgewert, zielrichtung = feld(ziel.stapel).folgewert
  dim as string startschieb = feld(start.stapel).folgeschieb
  dim as integer startschritt = 1, zielschritt = 1
  if len(startrichtung) = 3 andalso left(startrichtung, 2) = "ab" then
    startschritt = valint(right(startrichtung, 1))
    startrichtung = "ab"
  elseif len(startrichtung) = 4 andalso left(startrichtung, 3) = "auf" then
    startschritt = valint(right(startrichtung, 1))
    startrichtung = "auf"
  end if
  if len(zielrichtung) = 3 andalso left(zielrichtung, 2) = "ab" then
    zielschritt = valint(right(zielrichtung, 1))
    zielrichtung = "ab"
  elseif len(zielrichtung) = 4 andalso left(zielrichtung, 3) = "auf" then
    zielschritt = valint(right(zielrichtung, 1))
    zielrichtung = "auf"
  end if
  if richtung = -1 then
    ' Rueckwaertslegen braucht umgekehrte Legerichtung
    if startrichtung = "auf" then
      startrichtung = "ab"
    elseif startrichtung = "ab" then
      startrichtung = "auf"
    end if
    if startschieb = "wertauf" then
      startschieb = "wertab"
    elseif startschieb = "wertab" then
      startschieb = "wertauf"
    end if
    if startschieb = "nein" then startschieb = "wert" & startrichtung
  end if
  if anz = 0 then
    if feld(start.stapel).folgeschieb = "einzeln" then
      anz = 1
    else
      anz = feld(start.stapel).anzKarten - start.nr
    end if
  end if
  if anz < 1 then
    exit sub
  elseif anz = 1 then
    ' Einzelkarte legen
    for i as integer = feld(ziel.stapel).anzKarten - 1 to ziel.nr step -1
      feld(ziel.stapel).karte(i+1) = feld(ziel.stapel).karte(i)
    next
    feld(ziel.stapel).karte(ziel.nr) = start.karte
    feld(ziel.stapel).anzKarten += 1
    feld(start.stapel).anzKarten -= 1
    setzeJoker(feld(ziel.stapel), ziel.nr)
    for i as integer = start.nr to feld(start.stapel).anzKarten - 1
      feld(start.stapel).karte(i) = feld(start.stapel).karte(i+1)
    next
    feld(start.stapel).karte(feld(start.stapel).anzKarten) = type<TypKarte>(0, 0, 0, 0)
    stopptest start, ziel, einschubstopp
  else
    ' evtl. Einschieben
    for i as integer = feld(ziel.stapel).anzKarten - 1 to ziel.nr step -1
      feld(ziel.stapel).karte(i + anz) = feld(ziel.stapel).karte(i)
    next
    ' Stapel verschieben
    dim as integer i, k = ziel.nr
    if richtung = 1 then i = start.nr else i = start.nr + anz - 1
    do while (richtung > 0 and i <= start.nr + anz - 1) or (richtung < 0 and i >= start.nr)
      feld(ziel.stapel).karte(k) = feld(start.stapel).karte(i)
      feld(ziel.stapel).anzKarten += 1
      setzeJoker(feld(ziel.stapel), k)
      k += 1
      i += richtung
    loop
    for i as integer = start.nr + anz to feld(start.stapel).anzKarten-1
      feld(start.stapel).karte(i - anz) = feld(start.stapel).karte(i)
    next
    feld(start.stapel).anzKarten -= anz
    stopptest start, ziel, einschubstopp
  end if
  if feld(start.stapel).anzKarten > 0 andalso feld(start.stapel).karte(feld(start.stapel).anzKarten-1).status = Verdeckt then
    feld(start.stapel).karte(feld(start.stapel).anzKarten-1).status = Offen
    backpunkte = 0
  end if
  ' evtl. leeren Stapel auffuellen
  if start.nr = 0 andalso feld(start.stapel).fuellen <> "" then
    for i as integer = 1 to anzFelder
      if instr(feld(start.stapel).fuellen, feld(i).id) then
        if feld(i).anzKarten < 1 then stockaufnahme(type<TypTisch>(i, 0))
        if feld(i).anzKarten > 0 then stockaktion type<TypTisch>(i, feld(i).anzKarten - 1), start, 0
        if feld(start.stapel).anzKarten > 0 then exit for
      end if
    next
  end if
  if stockauf = 0 then sound_spielen sound_legen
  berechneTisch
  zeichne
end sub

function listeAdd(l as integer, inhalt as integer) as integer
  liste.ablauf &= mkl(inhalt) & mkl(iif(l = 0, len(liste.ablauf)\12 + 1, liste.erster(l))) & mkl(0)
  if l <> 0 then liste.ablauf = left(liste.ablauf, l*12 - 4) & mkl(len(liste.ablauf)\12) & mid(liste.ablauf, l*12 + 1)
  return len(liste.ablauf)\12
end function

function listeAdd(l as integer, typ as integer, id as string, inhalt as string, bedingung as string, spec as string) as integer
  anzListeninhalt += 1
  redim preserve listeninhalt(0 to anzListeninhalt)
  liste.ablauf &= mkl(anzListeninhalt) & mkl(iif(l = 0, len(liste.ablauf)\12 + 1, liste.erster(l))) & mkl(0)
  if l <> 0 then liste.ablauf = left(liste.ablauf, l*12 - 4) & mkl(len(liste.ablauf)\12) & mid(liste.ablauf, l*12 + 1)
  with listeninhalt(anzListeninhalt)
    .typ       = typ
    .id        = id
    .inhalt    = inhalt
    .bedingung = bedingung
    .spec      = spec
  end with
  return len(liste.ablauf)\12
end function

function menu as integer
  dim as any ptr speicher, balken
  dim as integer breite = 140, hoehe = 110, mx, my, mb, auswahl = 0, auswahlNeu
  dim as integer xstart = (maxX+4)*groesse-breite, ystart = (maxY+8)*groesse-hoehe-18
  dim as string taste
  speicher = imagecreate(breite, hoehe)
  balken = imagecreate(breite, 18, DGRAU)
  ' Menue zeichnen
  get (xstart, ystart)-step(breite-1, hoehe-1), speicher
  line (xstart, ystart)-step(breite-1, hoehe-1), HGRAU, bf
  line (xstart, ystart+hoehe-1)-step(breite-1, 0), DGRAU, bf
  draw string (xstart+16, ystart+5), "Spielabruch"
  draw string (xstart+16, ystart+20), "neues Spiel", iif(len(spielername), 0, &h606060)
  draw string (xstart+16, ystart+35), "speichern/Ende"
  draw string (xstart+2, ystart+50), "-----------------"
  draw string (xstart+16, ystart+65), "zur" & chr(129) & "cknehmen", iif(backpunkte > 0, 0, &h606060)
  draw string (xstart+16, ystart+80), "Animation"
  if animation then line (xstart+5, ystart+83)-step(3, 3) : line step(0, 0)-step(3, -6)
  draw string (xstart+16, ystart+95), "Anleitung"
  do
    getmouse mx, my,, mb
    sleep 1
  loop until mb = 0
  ' Menuepunkt auswaehlen
  do
    getmouse mx, my,, mb
    if mb = 2 then auswahl = 0 : exit do
    auswahlNeu = iif(mx > xstart and my > ystart and my < ystart+hoehe, (my-ystart)\15+1, 0)
    if auswahlNeu > 7 then auswahlNeu = 7
    if auswahl <> auswahlNeu then
      if auswahl > 0 and auswahl <> 4 and (auswahl <> 2 or len(spielername)) and (auswahl <> 5 or backpunkte > 0) then
        put (xstart, ystart+auswahl*15-15), balken, xor
      end if
      if auswahlNeu > 0 and auswahlNeu <> 4 and (auswahlNeu <> 2 or len(spielername)) and (auswahlNeu <> 5 or backpunkte > 0) then
        put (xstart, ystart+auswahlNeu*15-15), balken, xor
      end if
      auswahl = auswahlNeu
    end if
    taste = inkey
    if taste = chr(255, 107) then auswahl = -1 : exit do
  loop until mb = 1 or taste = chr(27)
  ' Bildschirm zuruecksetzen
  put (xstart, ystart), speicher, pset
  imagedestroy speicher
  imagedestroy balken
  return auswahl
end function

function parseLinks(text as string, start as integer, ziel as integer) as string
  dim as integer anfang, gatter = 0, ende, position = 0, bed
  dim as string idliste = text, feldname, linkname
  do while position < len(idliste)
    if idliste[position] = 32 or idliste[position] = 35 then
      if gatter = 0 then
        if idliste[position] = 32 then anfang = position else gatter = position
      else
        ende = position
        feldname = mid(idliste, anfang+2, gatter-anfang-1)
        linkname = mid(idliste, gatter+2, ende-gatter-1)
        for k as integer = 1 to anzFelder
          if feldname = "quelle" then
            if start <> k then continue for
          elseif feldname = "ziel" then
            if ziel <> k then continue for
          else
            if feld(k).id <> " " & feldname & " " then continue for
          end if
          bed = liste.erster(feld(k).llastBeziehung)
          do while bed <> 0
            if liste.id(bed) = " " & linkname & " " then
              idliste = parseLinks(left(idliste, anfang+1) & liste.inhalt(bed) & mid(idliste, ende+1), start, ende)
              gatter = 0
              position = anfang - 1
              exit do
            end if
            bed = liste.naechster(bed)
          loop
          exit for
        next
      end if
    end if
    position += 1
  loop
  return idliste
end function

function parseVariablen(text as string) as string
  ' ersetzt Variablen (wie zufallsfarbe durch den aktuellen Zufallswert)
  dim ret as string = text, tempint as integer = instr(ret, "zufallsfarbe")
  if tempint > 0 then ret = left(ret, tempint-1) & farben(zufallsfarbe) & mid(ret, tempint+12)
  tempint = instr(ret, "zufallswert")
  if tempint > 0 then
    if ret[tempint+10] = 43 then      ' zufallswert+X
      ret = left(ret, tempint-1) & werte((zufallswert+ret[tempint+11]-49) mod 13 + 1) & _
                mid(ret, tempint+13)
    elseif ret[tempint+10] = 45 then  ' zufallswert-X
      ret = left(ret, tempint-1) & werte((zufallswert-ret[tempint+11]+60) mod 13 + 1) & _
                mid(ret, tempint+13)
    else
      ret = left(ret, tempint-1) & werte(zufallswert) & mid(ret, tempint+11)
    end if
  end if
  return ret
end function

function pruefeAuto(start as TypTisch, ziel as integer) as integer
  ' pruefe, ob automatisches Legen von start auf ziel erlaubt ist
  ' (ohne Überprüfung, ob das tatsaechliche Legen erlaubt ist!)
  if (feld(ziel).spezial and SAuto) <> SAuto then return 0
  if feld(start.stapel).anzkarten = 0 then return 0
  if feld(start.stapel).karte(feld(start.stapel).anzkarten-1).spezial and SJoker then return 0
  if feld(ziel).auto = "" then return -1
  ' Eischraenkungen wegen Startkarte?
  for f as integer = 1 to 4
    if f <> start.karte.farbe andalso instr(" " & feld(ziel).auto & " ", " " & farben(f) & " ") then return 0
  next
  for w as integer = 2 to 14
    if w <> start.karte.wert andalso instr(" " & feld(ziel).auto & " ", " " & werte(w) & " ") then return 0
  next
  ' Einschränkung der Legefolge?
  dim as integer kartenzahl = 1
  if feld(ziel).anzKarten > 0 then kartenzahl = 2
  dim as TypKarte k(kartenzahl-1)
  k(kartenzahl-1) = start.karte
  if kartenzahl = 2 then k(0) = feld(ziel).karte(feld(ziel).anzKarten - 1)
  dim ffarbe as string = "frei", fwert as string = "frei", trenn as integer = instr(feld(ziel).auto, " ")
  if trenn > 0 then
    ffarbe = left(feld(ziel).auto, trenn-1)
    fwert = mid(feld(ziel).auto, trenn+1)
  else
    select case feld(ziel).auto
      case "farbe"       : ffarbe = "gleich"
      case "farbwechsel" : ffarbe = "wechsel"
      case "wert"        : fwert = "gleich"
      case "wertauf", "wertauf2" to "wertauf9", "wertab", "wertab2" to "wertab9", _
           "wertaufab", "wertaufab2" to "wertaufab9"
        fwert = mid(feld(ziel).auto, 5)
    end select
  end if
  dim as TypFeld temp = tempfeld(-1, 0, 0, ffarbe, fwert, "", "", -1, feld(ziel).spezial, k())
  return pruefeFolge(temp)
end function

function pruefeFolge(f as TypFeld) as integer
  ' prueft, ob das Feld eine korrekte Folge beinhaltet
  if f.anzKarten = 0 then return -1
  if f.anzKarten > 1 and f.startfarbe = 0 and f.startwert = 0 then return 0
  ' spezielle f.folgeschieb auswerten
  dim as string ffarbe = f.folgefarbe, fwert = f.folgewert
  dim as integer ewert = f.endwert
  select case f.folgeschieb
    case "frei"
      ' die obersten beiden Karten muessen offen sein
      if f.karte(0).status = Verdeckt then return 0
      if f.anzKarten > 0 andalso f.karte(1).status = Verdeckt then return 0
    case "offen" : ewert = 0
  end select
  ' Darf die Folge mit der Startkarte beginnen?
  if f.karte(0).spezial and SJoker then
    if f.startwert > 0 then f.karte(0).wert = f.startwert
    if f.startfarbe > 0 then f.karte(0).farbe = f.startfarbe
  elseif f.startfarbe <> -1 andalso ((f.startfarbe <> 0 and f.startfarbe <> f.karte(0).farbe) _
         or (f.startwert <> 0 and f.startwert <> f.karte(0).wert)) then
    return 0
  end if
  if f.startfarbe = 0 and f.startwert = 0 then return 0
  ' Folgen die Karten jeweils auf die vorhergehende?
  if f.karte(f.anzKarten - 1).status = Verdeckt then return 0
  for i as integer = 0 to f.anzKarten - 2
    if f.karte(i).status = Verdeckt then return 0
    if i > 0 and f.folgeschieb = "offen" then continue for
    setzeJoker(f, i+1)
    if f.karte(i).wert > 0 then
      select case fwert
        case "ab", "ab2" to "ab9"
          dim as integer tempint = 1
          if len(fwert) = 3 then tempint = valint(right(fwert, 1))
           if (f.karte(i).wert mod 13) <> ((f.karte(i+1).wert+tempint) mod 13) then return 0
        case "auf", "auf2" to "auf9"
          dim as integer tempint = 1
          if len(fwert) = 4 then tempint = valint(right(fwert, 1))
          if ((f.karte(i).wert+tempint) mod 13) <> (f.karte(i+1).wert mod 13) then return 0
        case "aufab", "aufab2" to "aufab9"
          /' TODO: NOCH KEIN JOKER UMGESETZT!
             ==> '/  if f.karte(i+1).spezial and SJoker then return 0
          dim as integer tempint = 1
          if len(fwert) = 6 then tempint = valint(right(fwert, 1))
          if abs(f.karte(i).wert-f.karte(i+1).wert) <> tempint and _
             abs(f.karte(i).wert-f.karte(i+1).wert) <> 13 - tempint then return 0
        case "gleich"
          if f.karte(i).wert <> f.karte(i+1).wert then return 0
        case "x2"
          if ((f.karte(i).wert*2) mod 13) <> (f.karte(i+1).wert mod 13) then return 0
      end select
    end if
    if f.karte(i).wert = ewert then return 0
    if f.karte(i).farbe > 0 then
      select case ffarbe
        case "gleich"
          if f.karte(i).farbe <> f.karte(i+1).farbe then return 0
        case "wechsel"
          if ((f.karte(i).farbe and 1) xor (f.karte(i+1).farbe and 1)) = 0 then return 0
      end select
    end if
    if ffarbe = "" and fwert = "" then return 0
    if f.folgeschieb = "frei" then exit for  ' keine weiteren Bedingungen
  next
  return -1
end function

function pruefeSperre(z as integer, typ as integer, s as integer = 0) as integer
  ' prueft, ob die Karte aktuell gesperrt ist
  if z < 1 or z > anzFelder or s < 0 or s > anzFelder then return 0
  dim sperren as string, felder as integer, funde as integer
  dim as TypFeld ziel = feld(z), start
  if s > 0 then start = feld(s)
  dim as integer bed = liste.erster(ziel.llastSperren)
  do while bed <> 0
    dim as integer spec = valint(liste.spec(bed))
    if (spec and typ) <> typ then bed = liste.naechster(bed) : continue do
    if spec and SsInaktiv then bed = liste.naechster(bed) : continue do
    sperren = liste.inhalt(bed)
    felder = 0
    funde = 0
    for k as integer = 1 to anzFelder
      if instr(sperren, feld(k).id) then
        felder += 1
        select case spec and 7
          case SsLeer
            if feld(k).anzKarten = 0 then return 0
            if typ = SsLegen andalso k = s and feld(k).anzKarten = 1 then funde += 1
          case SsBelegt : if feld(k).anzKarten > 0 then funde += 1
          case SsBelegbar
            if feld(k).anzKarten < feld(k).max then return 0
            if typ = SsLegen andalso k = s and feld(k).anzKarten = feld(k).max then funde += 1
          case SsVoll : if feld(k).anzKarten = feld(k).max then funde += 1
        end select
      end if
    next
    select case spec and (MOr or MAnd or MXor)
      case MOr  : if funde > 0 then return 0
      case MAnd : if funde = felder then return 0
      case MXor : if funde > 0 and funde < felder then return 0
    end select
    bed = liste.naechster(bed)
  loop
  return -1
end function

function pruefeVerschiebbar(start as TypTisch) as integer
  ' ueberpruefe, ob der Stapel ueberhaupt verschoben werden darf (fuer die grafische Darstellung)
  if start.karte.status = Verdeckt then return 0
  if feld(start.stapel).spezial and SVerdeckt then return 0
  if feld(start.stapel).spezial and SGesperrt then return 0
  ' nicht aufgeloeste Stopp-Aktion
  if stopp and SStopp1 then
    if (feld(start.stapel).spezial and SStopp1) = 0 then return 0
  end if
  if pruefeSperre(start.stapel, SsNehmen) = 0 then return 0
  if feld(start.stapel).folgeschieb = "einzeln" then return -1
  if feld(start.stapel).folgeschieb = "nein" and start.nr < feld(start.stapel).anzKarten -1 then return 0
  if feld(start.stapel).folgefarbe = "" and feld(start.stapel).folgeschieb = "" and _
     start.nr < feld(start.stapel).anzKarten-1 then return 0
  if feld(start.stapel).folgeschieb = "frei" then return -1
  ' nur gesamtes Verschieben
  if feld(start.stapel).folgeschieb = "gesamt" andalso start.nr > 0 then
    dim as TypKarte tkarte(1)
    with feld(start.stapel)
      tkarte(0) = .karte(start.nr - 1)
      tkarte(1) = .karte(start.nr)
      dim as TypFeld tfeld = tempfeld(-1, 0, .endwert, .folgefarbe, .folgewert, .folgeschieb, "", .max, .spezial, tkarte())
    end with
    if pruefeFolge(tfeld) then return 0
  end if
  ' weitere Folge ueberpruefen
  with feld(start.stapel)
    dim as string ffarbe = .folgefarbe, fwert = .folgewert
    dim as integer trenn = instr(.folgeschieb, " ")
    if .folgeschieb = "offen" then
      ffarbe = "frei"
      fwert = "frei"
    end if
    if .folgeschieb = "farbe" then
      ffarbe = "gleich"
    elseif .folgeschieb = "farbwechsel" then
      ffarbe = "wechsel"
    elseif .folgeschieb = "wert" then
      fwert = "gleich"
    elseif (left(.folgeschieb, 9) = "wertaufab" and len(.folgeschieb) < 11) or _
           (left(.folgeschieb, 7) = "wertauf" and len(.folgeschieb) < 9) or _
           (left(.folgeschieb, 6) = "wertab" and len(.folgeschieb) < 8) then fwert = mid(.folgeschieb, 5)
    elseif trenn > 0 then
      ffarbe = left(.folgeschieb, trenn-1)
      fwert = mid(.folgeschieb, trenn+1)
    end if
    if .anzKarten <= start.nr then return 0
    dim as TypKarte tkarte(.anzKarten - start.nr - 1)
    for i as integer = 0 to .anzKarten - start.nr - 1
      tkarte(i) = .karte(i + start.nr)
    next
    dim as TypFeld tfeld = tempfeld(-1, 0, .endwert, ffarbe, fwert, .folgeschieb, "", .max, .spezial, tkarte())
  end with
  if pruefeFolge(tfeld) = 0 then return 0
  return -1
end function

function pruefeWerte(wert1 as integer, wert2 as integer, vergleich as integer) as integer
  ' vergleicht zwei Werte je nach Vergleichsoption
  select case vergleich and VVergleich
    case VGleich               : if wert1 <> wert2 then return 0
    case VKleiner              : if wert1 >= wert2 then return 0
    case VKleiner or VGleich   : if wert1 >  wert2 then return 0
    case VGroesser             : if wert1 <= wert2 then return 0
    case VGroesser or VGleich  : if wert1 <  wert2 then return 0
    case VGroesser or VKleiner : if wert1 =  wert2 then return 0
  end select
  return -1
end function

sub setzeAttribut(feldptr as TypFeld ptr, attr as string, wert as string, spec as string = "")
  ' setzt ein Feldattribut
  if feldptr < 1 then exit sub
  with *feldptr
    select case attr
      case "var"
        if (left(wert, 1) = "+" or left(wert, 1) = "-") then .variable += valint(wert) else .variable = valint(wert)
        if .variable < 0 then .variable = 0
      case "max"
        if wert = "frei" or wert = "" then
          .max = 209
        elseif (left(wert, 1) = "+" or left(wert, 1) = "-") and .max < 209 then
          .max += valint(wert)
          if .max < 0 then .max = 0
          if .max > 208 then .max = 208
        else
          .max = valint(wert)
        end if
      case "wiederholung"
        if wert = "frei" then
          .wiederholung = -1
        elseif (left(wert, 1) = "+" or left(wert, 1) = "-") and .wiederholung >= 0 then
          .wiederholung += valint(wert)
          if .wiederholung < 0 then .wiederholung = 0
        else
          .wiederholung = valint(wert)
        end if
      case "folgestart"
        dim as integer farbeAlt = .startfarbe, wertAlt = .startwert
        if wert = "frei" then
          .startfarbe = -1
          .startwert = 0
        elseif wert= "" then
          .startfarbe = 0
          .startwert = 0
        else
          let (.startfarbe, .startwert) = kartenwertParse(wert)
          if .startfarbe = 0 then .startfarbe = iif(farbeAlt = -1, 0, farbeAlt)
          if .startwert = 0 then .startwert = wertAlt
          dim as integer nospec = not (SFarbstart or SWertstart or SBelegt or SVoll or SFrei)
          select case spec
            case "farbe"     : .spezial = (.spezial and nospec) or SFarbstart
            case "wert"      : .spezial = (.spezial and nospec) or SWertstart
            case "farbewert" : .spezial = (.spezial and nospec) or SFarbstart or SWertstart
            case "belegt"    : .spezial = (.spezial and nospec) or SBelegt
            case "voll"      : .spezial = (.spezial and nospec) or SVoll
            case "frei"      : .spezial = (.spezial and nospec) or SFrei
          end select
        end if
        dim as integer bed = liste.erster(.llastPunkte)
        do while bed > 0
          if liste.bedingung(bed) = "folge" or liste.bedingung(bed) = "folgestart" then
            if val(liste.id(bed)) = farbeAlt and val(liste.spec(bed)) = wertAlt then
              liste.id(bed) = str(feldptr->startfarbe)
              liste.spec(bed) = str(feldptr->startwert)
            end if
          end if
          bed = liste.naechster(bed)
        loop
      case "startfarbe"
        dim as integer farbeAlt = .startfarbe, wertAlt = .startwert
        if wert = "frei" then
          if .startwert = 0 then .startfarbe = -1 else .startfarbe = 0
        elseif wert = "" then
          .startfarbe = 0
        else
          for i as integer = 1 to 4
            if wert = farben(i) then .startfarbe = i
          next
        end if
        dim as integer bed = liste.erster(.llastPunkte)
        do while bed > 0
          if val(liste.id(bed)) = farbeAlt and val(liste.spec(bed)) = wertAlt then
            liste.id(bed) = str(feldptr->startfarbe)
            liste.spec(bed) = str(feldptr->startwert)
          end if
          bed = liste.naechster(bed)
        loop
      case "startwert"
        dim as integer farbeAlt = .startfarbe, wertAlt = .startwert
        if wert = "frei" then
          .startwert = 0
          if .startfarbe = 0 then .startfarbe = -1
        elseif wert = "" then
          .startwert = 0
        else
          for i as integer = 2 to 14
            if wert = werte(i) then .startwert = i
            if .startfarbe = -1 then .startfarbe = 0
          next
        end if
        dim as integer bed = liste.erster(.llastPunkte)
        do while bed > 0
          if val(liste.id(bed)) = farbeAlt and val(liste.spec(bed)) = wertAlt then
            liste.id(bed) = str(feldptr->startfarbe)
            liste.spec(bed) = str(feldptr->startwert)
          end if
          bed = liste.naechster(bed)
        loop
      case "folgeende"
        for i as integer = 2 to 14
          if wert = werte(i) then .endwert = i : exit for
        next
      case "folgefarbe"  : .folgefarbe = wert
      case "folgewert"   : .folgewert = wert
      case "folgeschieb" : .folgeschieb = wert
      case "einschub"    : .einschub = wert
      case "fuellen"     : .fuellen = " " & wert & " "
      case "rand"
        if wert = "nein" then
          .rand = -1
        elseif wert = "komplett" then
          if .eng*2 - 2 > .max then .rand = .eng-2 else .rand = .max-1
        elseif valint(wert) > 0 then
          .rand = valint(wert)
        end if
      case "sichtbar"
        if wert = "komplett" or wert = "" then .sichtbar = 209 else .sichtbar = valint(wert)
      case "anzeige"
        dim as integer bed = liste.erster(.llastAnzeigen)
        do while bed <> 0
          if trim(liste.id(bed)) = spec then
            if left(liste.inhalt(bed), 1) = "X" then
              if wert = "aktiv" then liste.inhalt(bed) = mid(liste.inhalt(bed), 2)
            else
              if wert = "inaktiv" then liste.inhalt(bed) = "X" & liste.inhalt(bed)
            end if
          end if
          bed = liste.naechster(bed)
        loop
      case "sperre"
        dim as integer bed = liste.erster(.llastSperren)
        do while bed <> 0
          dim as integer sperrspec = valint(liste.spec(bed))
          if trim(liste.id(bed)) = spec then
            if wert = "inaktiv" then
              sperrspec or= SsInaktiv
              liste.spec(bed) = str(sperrspec)
            elseif wert = "aktiv" then
              sperrspec and= not SsInaktiv
              liste.spec(bed) = str(sperrspec)
            end if
          end if
          bed = liste.naechster(bed)
        loop
      case "schiebsperre"
        dim as integer bed = liste.erster(.llastSchiebsperren)
        do while bed <> 0
          dim as integer sperrspec = valint(liste.spec(bed))
          if trim(liste.id(bed)) = spec then
            if wert = "inaktiv" then
              sperrspec or= SsInaktiv
              liste.spec(bed) = str(sperrspec)
            elseif wert = "aktiv" then
              sperrspec and= not SsInaktiv
              liste.spec(bed) = str(sperrspec)
            end if
          end if
          bed = liste.naechster(bed)
        loop
      case "stopp"
        if wert = "ja" then .spezial or= SStopp1 else .spezial and= (not SStopp1)
        stopptest type<TypTisch>(1), type<TypTisch>(1)
      case "gestoppt"
        if wert = "ja" then .spezial or= SStopp2 else .spezial and= (not SStopp2)
        stopptest type<TypTisch>(1), type<TypTisch>(1)
      case "sicht"    : if wert = "verdeckt" then .spezial or= SVerdeckt else .spezial and= not SVerdeckt
      case "status"
        dim as integer kartennr = valint(spec) - 1
        if kartennr < -1 then
          kartennr = .anzKarten + kartennr + 1
        elseif kartennr = -1 then
          kartennr = .anzKarten - 1
        end if
        if kartennr < 0 or kartennr >= .anzKarten then return
        if wert = "verdeckt" then .karte(kartennr).status = Verdeckt else .karte(kartennr).status = Offen
      case "gesperrt" : if wert = "ja" then .spezial or= SGesperrt else .spezial and= not SGesperrt
      case "auto"
        select case wert
          case "", "nein" : .spezial and= not SAuto : .auto = ""
          case "ja"       : .spezial or= SAuto      : .auto = ""
          case else       : .spezial or= SAuto      : .auto = wert
        end select
    end select
  end with
end sub

sub setzeBildschirm
  ' initiiert den Bildschirm, wenn notwendig in reduzierter Groesse
  dim as integer wb, wh, maxgroesse
  screeninfo wb, wh
  maxgroesse = iif(wb\(maxX+5) < wh\(maxY+10), wb\(maxX+5), wh\(maxY+10))
  maxgroesse = maxgroesse - (maxgroesse mod 2)
  if groesse > maxgroesse then
    groesse = maxgroesse
    if groesse > 16 then groesse = 16   ' Kartengroesse nur bis 64x96 garantiert
    if groesse < 10 then groesse = 10   ' Kartengroesse nur ab  40x60 garantiert
    kartenbilder = groesse*4 & mid(kartenbilder, 3)
    ruecken = groesse*4 & mid(ruecken, 3)
    ' Wenn die Groesse im gewaehlten Set nicht existiert, dann Standard-Set auswaehlen
    if dir("karten" & slash & kartenbilder, &h10) = "" then kartenbilder = groesse*4 & "standard"
    if dir("karten" & slash & "ruecken" & slash & ruecken & ".bmp") = "" then ruecken = groesse*4 & "standard"
  end if
  screenres (maxX+4)*groesse, (maxY+8)*groesse, 32, 2
  screenset 0, 0
end sub

sub setzeJoker(byref f as TypFeld, nr as integer)
  ' prueft, ob die Karte ein Joker ist, und setzt sie ggf. auf den passenden Wert
  if nr < 0 or nr >= f.anzKarten orelse (f.karte(nr).spezial and SJoker) = 0 then exit sub
  if nr = 0 then
    if f.startwert > 0 then
      f.karte(0).wert = f.startwert
    elseif f.anzKarten = 1 then
      f.karte(0).wert = 0
    end if
    if f.startfarbe > 0 then
      f.karte(0).farbe = f.startfarbe
    elseif f.anzKarten = 1 then
      f.karte(0).farbe = 0
    end if
  else
    select case f.folgewert
      case "ab", "ab2" to "ab9"
        dim as integer tempint = 1
        if len(f.folgewert) = 3 then tempint = valint(right(f.folgewert, 1))
        f.karte(nr).wert = (f.karte(nr-1).wert+13-tempint) mod 13
      case "auf", "auf2" to "auf9"
        dim as integer tempint = 1
        if len(f.folgewert) = 4 then tempint = valint(right(f.folgewert, 1))
        f.karte(nr).wert = (f.karte(nr-1).wert+tempint) mod 13
      case "aufab", "aufab2" to "aufab9"
        ' TODO: NOCH KEIN JOKER UMGESETZT!
      case "gleich"
        f.karte(nr).wert = f.karte(nr-1).wert
      case "x2"
        f.karte(nr).wert = f.karte(nr-1).wert*2 mod 13
    end select
    select case f.folgefarbe
      case "gleich"
        f.karte(nr).farbe = f.karte(nr-1).farbe
      case "wechsel"
        select case f.karte(nr-1).farbe
          case 0                   : f.karte(nr).farbe = 0
          case Herz, Karo, Rot     : f.karte(nr).farbe = Schwarz
          case Pik, Kreuz, Schwarz : f.karte(nr).farbe = Rot
        end select
    end select
  end if
end sub

sub sound_spielen(byval soundnr as uinteger)
  #ifdef SND
    if (sound and SOUND_EFFEKT_OK) = 0 then exit sub
    dim channel as HCHANNEL = BASS_SampleGetChannel(soundnr, 0)
    BASS_ChannelSetAttribute(channel, BASS_ATTRIB_VOL, 1)
    BASS_ChannelSetAttribute(channel, BASS_ATTRIB_PAN, 0)
    BASS_ChannelPlay(channel, 0)
  #endif
end sub

sub spielEnde(status as integer)
  endevariante = status
  select case status
    case EndeSieg             : aktionslauf ATypSieg, type<TypTisch>(1, 0, feld(1).karte(0))
    case EndeVerlust, EndeNeu : aktionslauf ATypVerlust, type<TypTisch>(1, 0, feld(1).karte(0))
  end select
  for i as integer = 0 to 55
    if kartenSenk then imagedestroy kartenbild(i)
    if kartenWaag then imagedestroy kartenbildQuer(i)
  next
  ' Spielergebnis zurueckgeben
  dim as integer f = freefile
  open cons for output as #f
  if punkte < 0 then punkte = 0
  print #f, endevariante*&h10000 + punkte
  close #f
  end
end sub

function spielLaden as integer
  dim f as integer = freefile, temp as long, lanz as long, dummy as long, version as ulong, listeAnz as long
  open pfad & "benutzer" & slash & spielername & slash & spieldatei & ".sav" for binary as #f
  get #f,, dummy  ' Dummywert (Spielzeit) - wird nur von patfinder benoetigt
  get #f,, version
  if version < (PROGRAMMVERSION and &hfff00000) then close #f : return 0
  get #f,, regel
  get #f,, maxX
  get #f,, maxY
  get #f,, kartenset
  get #f,, anzKarten
  get #f,, zufallsfarbe
  get #f,, zufallswert
  get #f,, stopp
  get #f,, punkte
  get #f,, punktemax
  get #f,, punktestart
  get #f,, level
  get #f,, Standardstock
  get #f,, Spielversion
  get #f,, BGC
  get #f,, markStopp
  get #f,, markKorrekt
  get #f,, listeAnz
  if listeAnz > 0 then
    dim as long listePosition(1 to listeAnz), listeErster(1 to listeAnz), listeNaechster(1 to listeAnz)
    listeErster(1) = 1
    for i as integer = 1 to listeAnz
      get #f,, listePosition(i)
      get #f,, listeNaechster(i)
      if listeErster(i) = 0 then listeErster(i) = i
      if listeNaechster(i) > 0 and listeNaechster(i) <= listeAnz then listeErster(listeNaechster(i)) = listeErster(i)
    next
    for i as integer = 1 to listeAnz
      liste.ablauf &= mkl(listePosition(i)) & mkl(listeErster(i)) & mkl(listeNaechster(i))
    next
  end if
  get #f,, anzListeninhalt
  redim listeninhalt(1 to anzListeninhalt)
  for i as integer = 1 to anzListeninhalt
    with listeninhalt(i)
      get #f,, .typ
      get #f,, temp
      if temp > 0 then .id = space(temp) : get #f,, .id
      get #f,, temp
      if temp > 0 then .inhalt = space(temp) : get #f,, .inhalt
      get #f,, temp
      if temp > 0 then .bedingung = space(temp) : get #f,, .bedingung
      get #f,, temp
      if temp > 0 then .spec = space(temp) : get #f,, .spec
    end with
  next
  get #f,, anzFelder
  redim feld(1 to anzFelder)
  for i as integer = 1 to anzFelder
    with feld(i)
      get #f,, .kuerzel
      get #f,, .anzkarten
      for k as integer = 0 to .anzkarten - 1
        get #f,, .karte(k)
      next
      get #f,, .max
      get #f,, .x
      get #f,, .y
      for i as integer = 0 to 26
        get #f,, .anfangskarten(i)
      next
      get #f,, .wiederholung
      get #f,, .spezial
      get #f,, .richtung
      get #f,, .rand
      get #f,, .eng
      get #f,, .startfarbe
      get #f,, .startwert
      get #f,, .endwert
      get #f,, .variable
      get #f,, .sichtbarAnfang
      get #f,, .sichtbar
      get #f,, temp
      if temp > 0 then .id = space(temp) : get #f,, .id
      get #f,, temp
      if temp > 0 then .folgefarbe = space(temp) : get #f,, .folgefarbe
      get #f,, temp
      if temp > 0 then .folgewert = space(temp) : get #f,, .folgewert
      get #f,, temp
      if temp > 0 then .folgeschieb = space(temp) : get #f,, .folgeschieb
      get #f,, temp
      if temp > 0 then .fuellen = space(temp) : get #f,, .fuellen
      get #f,, temp
      if temp > 0 then .einschub = space(temp) : get #f,, .einschub
      get #f,, temp
      if temp > 0 then .auto = space(temp) : get #f,, .auto
      get #f,, .llastQuellen
      get #f,, .llastZiele
      get #f,, .llastSperren
      get #f,, .llastSchiebsperren
      get #f,, .llastStopps
      get #f,, .llastAnzeigen
      get #f,, .llastBeziehung
      get #f,, .llastPunkte
    end with
  next
  get #f,, anzAktionen
  if anzAktionen > 0 then
    redim aktion(1 to anzAktionen)
    for i as integer = 1 to anzAktionen
      with aktion(i)
        get #f,, .typ
        get #f,, .erfolg
        get #f,, .misserfolg
        get #f,, temp
        if temp > 0 then .id = space(temp) : get #f,, .id
        get #f,, .llastBedingung
        get #f,, .llastVergleich
        get #f,, .llastaenderung
      end with
    next
  end if
  get #f,, anzAbschluss
  if anzAbschluss > 0 then
    redim abschluss(1 to anzAbschluss)
    for i as integer = 1 to anzAbschluss
      with abschluss(i)
        get #f,, .typ
        get #f,, .erfolg
        get #f,, .misserfolg
        get #f,, temp
        if temp > 0 then .id = space(temp) : get #f,, .id
        get #f,, .llastBedingung
        get #f,, .llastVergleich
        get #f,, .llastaenderung
      end with
    next
  end if
  get #f,, temp
  if temp > 0 then spielregel = space(temp) : get #f,, spielregel
  get #f,, temp
  if temp > 0 then spielname = space(temp) : get #f,, spielname
  get #f,, temp
  if temp > 0 then bemerkung = space(temp) : get #f,, bemerkung
  get #f,, temp
  if temp > 0 then anleitung = space(temp) : get #f,, anleitung
  close #f
  return -1
end function

sub spielSpeichern
  if stopp <> 0 and backpunkte > 0 then
    for i as integer = 1 to anzFelder
      feld(i) = backfeld(i)
    next
    stopp = 0
  end if
  dim as long f = freefile, dummy = 0
  open pfad & "benutzer" & slash & spielername & slash & spieldatei & ".sav" for output as #f
  put #f,, dummy
  put #f,, PROGRAMMVERSION
  put #f,, regel
  put #f,, maxX
  put #f,, maxY
  put #f,, kartenset
  put #f,, anzKarten
  put #f,, zufallsfarbe
  put #f,, zufallswert
  put #f,, stopp
  put #f,, punkte
  put #f,, punktemax
  put #f,, punktestart
  put #f,, level
  put #f,, Standardstock
  put #f,, Spielversion
  put #f,, BGC
  put #f,, markStopp
  put #f,, markKorrekt
  put #f,, cast(long, len(liste.ablauf)\12)
  for i as integer = 1 to len(liste.ablauf)\12
    put #f,, liste.position(i)
    put #f,, liste.naechster(i)
  next
  put #f,, anzListeninhalt
  for i as integer = 1 to anzListeninhalt
    with listeninhalt(i)
      put #f,, .typ
      put #f,, cast(long, len(.id))
      put #f,, .id
      put #f,, cast(long, len(.inhalt))
      put #f,, .inhalt
      put #f,, cast(long, len(.bedingung))
      put #f,, .bedingung
      put #f,, cast(long, len(.spec))
      put #f,, .spec
    end with
  next
  put #f,, anzFelder
  for i as integer = 1 to anzFelder
    with feld(i)
      put #f,, .kuerzel
      put #f,, .anzkarten
      for k as integer = 0 to .anzkarten - 1
        put #f,, .karte(k)
      next
      put #f,, .max
      put #f,, .x
      put #f,, .y
      for i as integer = 0 to 26
        put #f,, .anfangskarten(i)
      next
      put #f,, .wiederholung
      put #f,, .spezial
      put #f,, .richtung
      put #f,, .rand
      put #f,, .eng
      put #f,, .startfarbe
      put #f,, .startwert
      put #f,, .endwert
      put #f,, .variable
      put #f,, .sichtbarAnfang
      put #f,, .sichtbar
      put #f,, cast(long, len(.id))
      put #f,, .id
      put #f,, cast(long, len(.folgefarbe))
      put #f,, .folgefarbe
      put #f,, cast(long, len(.folgewert))
      put #f,, .folgewert
      put #f,, cast(long, len(.folgeschieb))
      put #f,, .folgeschieb
      put #f,, cast(long, len(.fuellen))
      put #f,, .fuellen
      put #f,, cast(long, len(.einschub))
      put #f,, .einschub
      put #f,, cast(long, len(.auto))
      put #f,, .auto
      put #f,, .llastQuellen
      put #f,, .llastZiele
      put #f,, .llastSperren
      put #f,, .llastSchiebsperren
      put #f,, .llastStopps
      put #f,, .llastAnzeigen
      put #f,, .llastBeziehung
      put #f,, .llastPunkte
    end with
  next
  put #f,, anzAktionen
  for i as integer = 1 to anzAktionen
    with aktion(i)
      put #f,, .typ
      put #f,, .erfolg
      put #f,, .misserfolg
      put #f,, cast(long, len(.id))
      put #f,, .id
      put #f,, .llastBedingung
      put #f,, .llastVergleich
      put #f,, .llastaenderung
    end with
  next
  put #f,, anzAbschluss
  for i as integer = 1 to anzAbschluss
    with abschluss(i)
      put #f,, .typ
      put #f,, .erfolg
      put #f,, .misserfolg
      put #f,, cast(long, len(.id))
      put #f,, .id
      put #f,, .llastBedingung
      put #f,, .llastVergleich
      put #f,, .llastaenderung
    end with
  next
  put #f,, cast(long, len(spielregel))
  put #f,, spielregel
  put #f,, cast(long, len(spielname))
  put #f,, spielname
  put #f,, cast(long, len(bemerkung))
  put #f,, bemerkung
  put #f,, cast(long, len(anleitung))
  put #f,, anleitung
  close #f
end sub

sub stockaktion(start as TypTisch, ziel as TypTisch = type<TypTisch>(0, 0), sperrung as integer = -1)
  ' Kartengeben vom Stock; evtl. neu aufnehmen
  ' sperrung = 0: auch von gesperrten Stapeln kann gegeben werden (fuer automatisches Fuellen)
  dim as integer stockauf = 0
  ' gesperrter Stock
  if feld(start.stapel).spezial and SGesperrt and sperrung then exit sub
  ' Sperre aufgrund des "Ueberschreitens" einer Maximalzahl
  if stopp and SStopp1 then
    if (feld(start.stapel).spezial and SStopp1) = 0 then exit sub
  end if
  ' Sperre aufgrund fehlender Karte
  if stopp and SStopp2 then
    for k as integer = 1 to anzFelder
      if feld(k).spezial and SStopp2 then
        dim as integer ok = 0
        dim as integer ziel = liste.erster(feld(start.stapel).llastZiele)
        do while ziel <> 0
          if instr(liste.inhalt(ziel), feld(k).id) then ok = -1 : exit do
          ziel = liste.naechster(ziel)
        loop
        if ok = 0 then exit sub
      end if
    next
  end if
  ' gesperrten Stock uebergehen
  if pruefeSperre(start.stapel, SsNehmen) = 0 then exit sub
  backpunkte = 0 ' nach einer Stockaktion ist kein 'Rueckgaengig' moeglich
  if feld(start.stapel).anzKarten < 1 and feld(start.stapel).wiederholung <> 0 then
    ' leeren Stock neu aufnehmen
    stockaufnahme start
    if (feld(start.stapel).spezial and SSprung) = 0 then exit sub
    stockauf = -1
    start = type<TypTisch>(start.stapel, feld(start.stapel).anzKarten - 1, _
            feld(start.stapel).karte(feld(start.stapel).anzKarten - 1))
  end if
  ' Karte geben
  if ziel.stapel = 0 then
    dim as integer ziel = liste.erster(feld(start.stapel).llastZiele)
    do while ziel <> 0
      for k as integer = 1 to anzFelder
        if instr(liste.inhalt(ziel), feld(k).id) then
          ' Ueberpruefe, ob eine Legebedingung vorliegt
          select case mid(liste.bedingung(ziel), 3)
            case "leer"     : if feld(k).anzKarten > 0 then continue for
            case "belegbar" : if feld(k).anzKarten >= feld(k).max then continue for
            case "belegt"   : if feld(k).anzKarten < 1 then continue for
            case "erlaubt"  : if legeversuch(start, type<TypTisch>(k, feld(k).anzkarten-1)) = 0 then continue for
            case "keinefolge"
              for l as integer = feld(k).anzkarten-1 to 0 step -1
                if feld(k).karte(l).wert = feld(k).startwert then
                  if pruefeVerschiebbar(type<TypTisch>(k, l)) then continue for, for else exit for
                end if
              next
            case "folge"
              dim as integer l
              for l = feld(k).anzkarten-1 to 0 step -1
                if feld(k).karte(l).wert = feld(k).startwert then
                  if pruefeVerschiebbar(type<TypTisch>(k, l)) then exit for else continue for, for
                end if
              next
              if l = -1 then continue for
          end select
          ' alles in Ordnung; evtl. wird aber ein anderer Stapel bedient
          if feld(start.stapel).anzKarten > 0 then
            feld(start.stapel).karte(feld(start.stapel).anzKarten-1).status _
                = iif(left(liste.bedingung(ziel), 1) = "v", Verdeckt, Offen)
          end if
          if liste.spec(ziel) <> "" then
            dim as integer gelegt = 0
            for j as integer = 1 to anzFelder
              if instr(liste.id(ziel), liste.spec(ziel)) then
                if legeversuch(start, type<TypTisch>(j, feld(j).anzkarten), 0) then
                  backup
                  lege start, type<TypTisch>(j, feld(j).anzkarten),, 0, stockauf
                  gelegt = -1
                  if start.nr = 0 then exit for
                  start.nr -= 1
                  start.karte = feld(start.stapel).karte(start.nr)
                  exit for
                end if
              end if
            next
            if gelegt then
              if start.nr = 0 then exit for else continue for
            end if
          end if
          ' es kann gelegt werden
          backpunkte = 0
          lege start, type<TypTisch>(k, feld(k).anzKarten),, 0, stockauf
          if start.nr = 0 then exit for
          start.nr -= 1
          start.karte = feld(start.stapel).karte(start.nr)
        end if
      next
      if start.nr < 0 then exit do
      ziel = liste.naechster(ziel)
    loop
  else
    lege start, ziel,, 0, stockauf
  end if
end sub

sub stockaufnahme(start as TypTisch)
  ' Ablagestapel aufnehmen, evtl. neu mischen
  if feld(start.stapel).wiederholung = 0 then exit sub
  dim as integer soundGespielt = 0
  if feld(start.stapel).wiederholung > 0 then feld(start.stapel).wiederholung -= 1
  dim as integer quelle = liste.erster(feld(start.stapel).llastQuellen)
  do while quelle <> 0
    for k as integer = 1 to anzFelder
      if instr(liste.inhalt(quelle), feld(k).id) then
        if feld(k).anzKarten > 0 then
          for i as integer = 0 to feld(k).anzKarten - 1
            feld(k).karte(i).status = Offen
          next
          lege type<TypTisch>(k, 0), start, -1
          if soundGespielt = 0 then
            sound_spielen sound_misch
            soundGespielt = -1
          end if
        end if
      end if
      next
    quelle = liste.naechster(quelle)
  loop
  if feld(start.stapel).spezial and SMischen then
    for i as integer = 0 to feld(start.stapel).anzKarten - 1
      for k as integer = i + 1 to feld(start.stapel).anzKarten - 1
        if rnd*(k-i+1) < 1 then swap feld(start.stapel).karte(i), feld(start.stapel).karte(k)
      next
    next
  end if
end sub

sub stopptest(start as TypTisch, ziel as TypTisch, einschubstopp as integer = -1)
  ' sperren oder Sperre bestaetigen
  feld(start.stapel).spezial and= not (SStopp1 or SStopp2)
  feld(ziel.stapel).spezial and= not (SStopp1 or SStopp2)
  dim as TypFeld zielfeld = feld(ziel.stapel)
  dim as integer bed = liste.erster(feld(ziel.stapel).llastStopps)
  do while bed <> 0
    select case liste.bedingung(bed)
      case "kartenzahl"
        if liste.inhalt(bed) = "max" then
          if zielfeld.anzKarten >= zielfeld.max then feld(ziel.stapel).spezial or= SStopp1
        elseif zielfeld.anzKarten >= valint(liste.inhalt(bed)) then
          feld(ziel.stapel).spezial or= SStopp1
        end if
      case "einschub"
        if zielfeld.anzKarten > 0 then
          if einschubstopp andalso liste.inhalt(bed) = "wert" and _
             zielfeld.karte(zielfeld.anzKarten-1).wert <> zielfeld.startwert then
            feld(ziel.stapel).spezial or= SStopp1
          elseif liste.inhalt(bed) = "farbe" and _
             zielfeld.karte(zielfeld.anzKarten-1).farbe <> zielfeld.startfarbe then
            feld(ziel.stapel).spezial or= SStopp1
          end if
        end if
    end select
    bed = liste.naechster(bed)
  loop
  bed = liste.erster(feld(start.stapel).llastStopps)
  do while bed <> 0
    select case liste.bedingung(bed)
      case "kartenzahl"
        if liste.inhalt(bed) = "max" then
          if feld(start.stapel).anzKarten >= feld(start.stapel).max then feld(start.stapel).spezial or= SStopp1
        elseif feld(start.stapel).anzKarten >= valint(liste.inhalt(bed)) then
          feld(start.stapel).spezial or= SStopp1
        end if
      case "leer"
        if feld(start.stapel).anzKarten = 0 then feld(start.stapel).spezial or= SStopp2
    end select
    bed = liste.naechster(bed)
  loop
  ' entsperren?
  stopp = 0
  for i as integer = 1 to anzFelder
    if feld(i).spezial and SStopp1 then stopp or= SStopp1
    if feld(i).spezial and SStopp2 then stopp or= SStopp2
  next
end sub

function tempfeld(sfarbe as integer, swert as integer, ewert as integer, ffarbe as string, fwert as string, _
                  fschieb as string, einschub as string, mmax as integer, spezial as integer, k() as TypKarte) as TypFeld
  ' erstellt ein temporaeres Feld zur Ueberpruefung mit pruefeFolge()
  dim as TypFeld ret
  ret.startfarbe = sfarbe
  ret.startwert = swert
  ret.endwert = ewert
  ret.folgefarbe = ffarbe
  ret.folgewert = fwert
  ret.folgeschieb = fschieb
  ret.einschub = einschub
  ret.max = mmax
  ret.spezial = spezial
  ret.anzKarten = ubound(k) + 1
  for i as integer = 0 to ubound(k)
    ret.karte(i) = k(i)
  next
  return ret
end function

function wert2karte(wert as integer) as TypKarte
  select case wert
    case -15, -14  : return type<TypKarte>(-1, 0)
    case -13 to -1 : return type<TypKarte>(0, wert+15)
    case 0 to 56   : return type<TypKarte>((wert+15)\14, (wert mod 14) + 1)
    case 57        : return type<TypKarte>(0, 0, 0, SJoker)
    case else      : return type<TypKarte>(0)
  end select
end function

sub zeichne(opt as integer = 0)
  ' zeichnet das komplette Feld; opt <> 0 zeichnet auch dann, wenn Zeichnen gesperrt wurde
  if (_Neuzeichnen or opt) = 0 then exit sub
  dim as integer wert, x, y, quer, anzeigestart
  screencopy 1 - aktuellerScreen, aktuellerScreen
  aktuellerScreen = 1 - aktuellerScreen
  screensync
  screenset aktuellerScreen, 1 - aktuellerScreen
  cls
  ' erst Leerfelder zeichnen
  for i as integer = anzFelder to 1 step -1
    with feld(i)
      quer = (.spezial and SQuer) = SQuer
      if .x < 0 or .y < 0 or .sichtbar < 1 then continue for
      x = .x
      y = .y
      if .eng > 0 andalso .rand >= .eng then
        richtungsadd .richtung, x, y, -.rand, .rand, -.rand, .rand
      else
        richtungsadd .richtung, x, y, -2*.rand, 2*.rand, -2*.rand, 2*.rand
      end if
      for k as integer = .rand to 0 step -1
        zeichneKarte x, y, 0, quer
        if .eng > 0 andalso .rand >= .eng then
          richtungsadd .richtung, x, y, 1, -1, 1, -1
        else
          richtungsadd .richtung, x, y, 2, -2, 2, -2
        end if
      next
      if .anzkarten = 0 then
        dim as string ausgabe = " ", temp
        for k as integer = 1 to 4
          if feld(i).startfarbe = k then ausgabe &= chr(k*2 + iif(k<3, 1, -2), 32)
        next
        for k as integer = 2 to 14
          if feld(i).startwert = k then ausgabe &= werte(k) & " "
        next
        draw string ((feld(i).x + 2 - quer)*groesse - len(ausgabe)*4, (feld(i).y + 3 + quer)*groesse - 4), ausgabe, &h555555
      end if
    end with
  next
  ' jetzt alle anderen
  for i as integer = anzFelder to 1 step -1
    with feld(i)
      x = .x
      y = .y
      if x < 0 or y < 0 or .sichtbar < 1 then continue for
      quer = (.spezial and SQuer) = SQuer
      anzeigestart = iif(.sichtbar < .anzkarten, .anzKarten-.sichtbar, 0)
      for k as integer = anzeigestart to .anzKarten - 1
        if .karte(k).wert = 0 and .karte(k).spezial <> SJoker then  ' leerer Platz nur bei entsprechender Randbedingung fuellen
        else
          if .karte(k).status = Verdeckt or (.spezial and SVerdeckt) <> 0 then
            zeichneKarte x, y, 53 - ((.karte(k).spezial and Hintergrund2) = Hintergrund2), quer
          else
            zeichneKarte x, y, kartenwert(.karte(k)), quer
          end if
        end if
        if k < .anzKarten - 1 then
          if .eng > 0 andalso .anzKarten >= .eng then
            richtungsadd .richtung, x, y, -1, 1, -1, 1
          else
            richtungsadd .richtung, x, y, -2, 2, -2, 2
          end if
        end if
      next
      ' farbliche Markierung
      if .spezial and (SStopp1 or SStopp2) andalso markStopp < &hffffff then
        line (x*groesse-1, y*groesse-1)-step((4 - 2*quer)*groesse + 1, (6 + 2*quer)*groesse + 1), markStopp, b
        line (x*groesse, y*groesse)-step((4 - 2*quer)*groesse - 1, (6 + 2*quer)*groesse - 1), markStopp, b
      end if
      if markKorrekt < &hffffff andalso .anzKarten > 0 andalso _
         (.startfarbe = -1 or .startfarbe = 0 or .startfarbe = .karte(0).farbe) and _
          (.startwert = 0 or .startwert = .karte(0).wert) andalso (.startfarbe > 0 or .startwert > 0) then
        line (x*groesse-1, y*groesse-1)-step((4 - 2*quer)*groesse + 1, (6 + 2*quer)*groesse + 1), markKorrekt, b
        line (x*groesse, y*groesse)-step((4 - 2*quer)*groesse - 1, (6 + 2*quer)*groesse - 1), markKorrekt, b
      end if
      ' Textanzeigen
      dim as integer bed = liste.erster(.llastAnzeigen)
      do while bed <> 0
        if .rand = -1 and .anzKarten = 0 then exit do
        if left(liste.inhalt(bed), 1) <> "X" then
          dim as string tempstring = attribut(i, liste.bedingung(bed), "") & liste.spec(bed)
          dim as integer richtung = sucheRichtung(liste.inhalt(bed)), neux = x, neuy = y
          if ((richtung and RLinks) andalso (.richtung and RRechts)) orelse _
             ((richtung and RRechts) andalso (.richtung and RLinks)) orelse _
             ((richtung and ROben) andalso (.richtung and RUnten)) orelse _
             ((richtung and RUnten) andalso (.richtung and ROben)) then _
             neux = .x : neuy = .y
          if richtung and RLinks then
            neux = (neux + 3 - quer)*groesse - 8*len(tempstring)
          elseif richtung and RRechts then
            neux = (neux + 1 - quer)*groesse
          else
            neux = (neux + 2 - quer)*groesse - 4*len(tempstring)
          end if
          neuy = (neuy + 3 + quer)*groesse - 4
          richtungsadd richtung, neux, neuy, -4*groesse, 4*groesse, -3.5*groesse, 3.5*groesse
          draw string (neux, neuy), tempstring
        end if
        bed = liste.naechster(bed)
      loop
    end with
  next
  line (0, (maxY + 6)*groesse + 1)-step((maxX+4)*groesse, 2*groesse - 1), HGRAU, bf
  draw string (groesse, (maxY+7)*groesse-3), "Punkte: " & punkte & iif(punktemax > 0, "/" & punktemax, "")
  if Standardstock > 0 andalso feld(Standardstock).wiederholung > 0 then
    draw string (16*groesse, (maxY+7)*groesse-3), "noch " & feld(Standardstock).wiederholung & "x geben"
  end if
  draw string ((maxX+2)*groesse-20, (maxY+7)*groesse-3), "MENU"
  screencopy
  screensync
  screenset aktuellerScreen, aktuellerScreen
end sub

sub zeichneKarte(x as integer, y as integer, wert as integer, quer as integer = 0)
  ' zeichnet eine Karte
  if x < 0 or y < 0 or wert < 0 or wert > 55 then exit sub
  if quer then
    if x > maxX - 2 or y > maxY + 2 then exit sub
  else
    if x > maxX or y > maxY then exit sub
  end if
  if quer then
    put (x*groesse, y*groesse), kartenbildQuer(wert), trans
  else
    put (x*groesse, y*groesse), kartenbild(wert), trans
  end if
end sub
